#  Copyright (C) 1999-2004
#  Smithsonian Astrophysical Observatory, Cambridge, MA, USA
#  For conditions of distribution and use, see copyright notice in "copyright"

package provide DS9 1.0

proc UpdateMagnifier {which x y} {
    global mag

    if {$mag(view)} {
	$which magnifier update $x $y
    }
}

proc ChangeMagnifierRegion {} {
    global mag
    global ds9
    
    foreach f $ds9(frames) {
	$f magnifier graphics $mag(region)
    }
}

proc ChangeMagnifierCursor {} {
    global mag
    global ds9
    
    foreach f $ds9(frames) {
	$f magnifier cursor $mag(cursor)
    }
}

proc MagnifierZoomTo {} {
    global mag
    global ds9

    foreach f $ds9(frames) {
	$f magnifier zoom $mag(zoom)
    }
}
