/* A Bison parser, made from ds9parser.Y
   by GNU bison 1.35.  */

#define YYBISON 1  /* Identify Bison output.  */

#define yyparse mkparse
#define yylex mklex
#define yyerror mkerror
#define yylval mklval
#define yychar mkchar
#define yydebug mkdebug
#define yynerrs mknerrs
# define	INT	257
# define	REAL	258
# define	STRING	259
# define	HOUR	260
# define	MINUTE	261
# define	SECOND	262
# define	DEGREE	263
# define	ARCMINUTE	264
# define	ARCSECOND	265
# define	RADIAN	266
# define	PHYCOORD	267
# define	IMGCOORD	268
# define	SEXSTR	269
# define	AMPLIFIER_	270
# define	ANNULUS_	271
# define	ARCMIN_	272
# define	ARCSEC_	273
# define	ARROW_	274
# define	B1950_	275
# define	BACKGROUND_	276
# define	BOX_	277
# define	BOXCIRCLE_	278
# define	CIRCLE_	279
# define	COLOR_	280
# define	COMPASS_	281
# define	CROSS_	282
# define	DEBUG_	283
# define	DEGREES_	284
# define	DELETE_	285
# define	DETECTOR_	286
# define	DIAMOND_	287
# define	ECLIPTIC_	288
# define	EDIT_	289
# define	ELLIPSE_	290
# define	FALSE_	291
# define	FIELD_	292
# define	FIXED_	293
# define	FK4_	294
# define	FK5_	295
# define	FONT_	296
# define	GALACTIC_	297
# define	GLOBAL_	298
# define	HIGHLITE_	299
# define	ICRS_	300
# define	IGNORE_	301
# define	IMAGE_	302
# define	INCLUDE_	303
# define	J2000_	304
# define	LINE_	305
# define	LINEAR_	306
# define	MOVE_	307
# define	N_	308
# define	NO_	309
# define	OFF_	310
# define	ON_	311
# define	PANDA_	312
# define	PHYSICAL_	313
# define	PIE_	314
# define	PIXELS_	315
# define	POINT_	316
# define	POLYGON_	317
# define	PROJECTION_	318
# define	ROTATE_	319
# define	ROTBOX_	320
# define	RULER_	321
# define	SELECT_	322
# define	SOURCE_	323
# define	TAG_	324
# define	TEXT_	325
# define	TEXTANGLE_	326
# define	TILE_	327
# define	TRUE_	328
# define	VERSION_	329
# define	WCS_	330
# define	WCSA_	331
# define	WCSB_	332
# define	WCSC_	333
# define	WCSD_	334
# define	WCSE_	335
# define	WCSF_	336
# define	WCSG_	337
# define	WCSH_	338
# define	WCSI_	339
# define	WCSJ_	340
# define	WCSK_	341
# define	WCSL_	342
# define	WCSM_	343
# define	WCSN_	344
# define	WCSO_	345
# define	WCSP_	346
# define	WCSQ_	347
# define	WCSR_	348
# define	WCSS_	349
# define	WCST_	350
# define	WCSU_	351
# define	WCSV_	352
# define	WCSW_	353
# define	WCSX_	354
# define	WCSY_	355
# define	WCSZ_	356
# define	WIDTH_	357
# define	X_	358
# define	Y_	359
# define	YES_	360

#line 5 "ds9parser.Y"

#define YYPARSE_PARAM fr
#define YYDEBUG 1

#define FR ((FrameBase*)fr)
#define FITSPTR (FR->findFits(globalTile))

#define DISCARD_(x) {yyclearin; mkDiscard(x);}

#include <math.h>
#include <string.h>
#include <iostream.h>

#include "framebase.h"
#include "fitsimage.h"
#include "util.h"
#include "vector.h"
#include "list.h"
#include "basemarker.h"
#include "coord.h"

extern int mklex(void);
extern void mkerror(const char*);
extern void mkDiscard(int);

int mksign;
int mksign2;

static CoordSystem globalSystem;
static CoordSystem globalWCS;
static SkyFrame globalSky;
static CoordSystem localSystem;
static SkyFrame localSky;

static int globalTile;

static unsigned short globalProps;
static unsigned short localProps;

static int globalWidth;
static int localWidth;

static char globalColor[16];
static char localColor[16];

static char globalFont[32];
static char localFont[32];

static char globalText[80];
static char localText[80];

static char localComment[80];

static int globalLine1;
static int localLine1;
static int globalLine2;
static int localLine2;

static int globalPoint;
static int localPoint;

static double globalTextAngle;
static double localTextAngle;

static CoordSystem globalRulerCoordSystem;
static CoordSystem localRulerCoordSystem;
static SkyFrame globalRulerSkyFrame;
static SkyFrame localRulerSkyFrame;
static CoordSystem globalRulerDistSystem;
static CoordSystem localRulerDistSystem;
static SkyFormat globalRulerDistFormat;
static SkyFormat localRulerDistFormat;

static CoordSystem globalCompassCoordSystem;
static SkyFrame globalCompassSkyFrame;
static char globalCompassNorth[80];
static char globalCompassEast[80];
static int globalCompassNArrow;
static int globalCompassEArrow;
static CoordSystem localCompassCoordSystem;
static SkyFrame localCompassSkyFrame;
static char localCompassNorth[80];
static char localCompassEast[80];
static int localCompassNArrow;
static int localCompassEArrow;

static int localPanda;

static List<Vertex> polylist;
static List<Tag> taglist;

static double aAnnuli[MAXANNULI];
static Vector aVector[MAXANNULI];
static int aNum;
static int aNumsao;
static int aStatus;
static Vector aCenter;
static double aAngle[MAXANGLES];
static int aAngNum;
static unsigned short aProps;
static char aColor[16];
static int aWidth;
static char aFont[32];
static char aText[80];
static char aComment[80];

static void setProps(unsigned short* props, unsigned short prop, int value);
static CoordSystem checkWCSSystem();
static SkyFrame checkWCSSky();

enum {CIRCLE,BOX,DIAMOND,CROSS,XPT,ARROW,BOXCIRCLE};
	

#line 119 "ds9parser.Y"
#ifndef YYSTYPE
typedef union {
  double real;
  int integer;
  char str[256];
  double vector[3];
} yystype;
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif
#ifndef YYDEBUG
# define YYDEBUG 0
#endif



#define	YYFINAL		571
#define	YYFLAG		-32768
#define	YYNTBASE	118

/* YYTRANSLATE(YYLEX) -- Bison token number corresponding to YYLEX. */
#define YYTRANSLATE(x) ((unsigned)(x) <= 360 ? yytranslate[x] : 178)

/* YYTRANSLATE[YYLEX] -- Bison token number corresponding to YYLEX. */
static const char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     108,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   117,     2,   107,     2,     2,   116,     2,
     111,   112,     2,   114,   110,   115,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,   109,
       2,   113,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106
};

#if YYDEBUG
static const short yyprhs[] =
{
       0,     0,     4,     8,    11,    12,    15,    17,    21,    24,
      25,    29,    30,    34,    35,    39,    43,    45,    46,    50,
      51,    52,    56,    58,    59,    64,    68,    69,    75,    77,
      79,    81,    83,    85,    87,    89,    91,    93,    95,    97,
      99,   101,   103,   105,   106,   108,   109,   111,   112,   114,
     115,   117,   119,   121,   123,   125,   127,   129,   131,   133,
     135,   139,   143,   147,   151,   155,   159,   163,   165,   169,
     170,   179,   180,   189,   193,   197,   201,   205,   209,   213,
     215,   217,   219,   221,   223,   225,   227,   229,   231,   233,
     235,   237,   239,   241,   243,   245,   247,   249,   251,   253,
     255,   257,   259,   261,   263,   265,   267,   269,   271,   273,
     275,   277,   279,   281,   283,   285,   287,   289,   291,   293,
     295,   297,   299,   301,   303,   305,   307,   309,   311,   313,
     315,   319,   321,   325,   329,   333,   337,   341,   343,   345,
     349,   354,   358,   366,   370,   374,   379,   382,   385,   388,
     391,   394,   397,   399,   401,   404,   406,   408,   410,   411,
     415,   417,   421,   425,   429,   433,   437,   441,   443,   445,
     449,   454,   458,   466,   470,   474,   479,   482,   485,   488,
     491,   494,   497,   499,   501,   504,   506,   508,   510,   511,
     519,   521,   522,   524,   526,   528,   530,   532,   534,   536,
     537,   539,   541,   549,   559,   569,   579,   580,   587,   595,
     601,   602,   611,   619,   627,   637,   643,   650,   657,   664,
     671,   678,   685,   692,   702,   714,   726,   738,   752,   766,
     785,   797,   811,   825,   844,   862,   872,   884,   896,   901,
     905,   907,   909,   913,   915,   917,   921,   923,   925,   929,
     931,   935
};
static const short yyrhs[] =
{
     156,   119,   177,     0,   119,   120,   131,     0,   120,   131,
       0,     0,    29,   133,     0,    75,     0,    44,   152,   126,
       0,    73,     3,     0,     0,   147,   121,   126,     0,     0,
     149,   122,   126,     0,     0,    52,   123,   126,     0,   163,
     165,   166,     0,   124,     0,     0,   107,   125,     5,     0,
       0,     0,   107,   127,     5,     0,   177,     0,     0,   107,
     129,     5,   177,     0,   107,   157,   177,     0,     0,   107,
     157,   130,     5,   177,     0,   108,     0,   109,     0,     4,
       0,     3,     0,    57,     0,    56,     0,     3,     0,   106,
       0,   105,     0,    57,     0,    74,     0,    55,     0,    54,
       0,    56,     0,    37,     0,     0,   110,     0,     0,   111,
       0,     0,   112,     0,     0,   139,     0,   132,     0,     9,
       0,    12,     0,   132,     0,    13,     0,    14,     0,     9,
       0,    10,     0,    11,     0,   132,   135,   132,     0,    13,
     135,    13,     0,    14,   135,    14,     0,     9,   135,     9,
       0,    10,   135,    10,     0,    11,   135,    11,     0,    54,
     113,     3,     0,    15,     0,   143,   135,   143,     0,     0,
       6,     7,     8,   145,   135,     3,    10,    11,     0,     0,
       3,    10,    11,   146,   135,     3,    10,    11,     0,   132,
     135,   132,     0,     9,   135,     9,     0,    14,   135,    14,
       0,    13,   135,    13,     0,    14,   135,    13,     0,    13,
     135,    14,     0,    48,     0,    59,     0,    32,     0,    16,
       0,   148,     0,    76,     0,    77,     0,    78,     0,    79,
       0,    80,     0,    81,     0,    82,     0,    83,     0,    84,
       0,    85,     0,    86,     0,    87,     0,    88,     0,    89,
       0,    90,     0,    91,     0,    92,     0,    93,     0,    94,
       0,    95,     0,    96,     0,    97,     0,    98,     0,    99,
       0,   100,     0,   101,     0,   102,     0,    40,     0,    21,
       0,    41,     0,    50,     0,    46,     0,    43,     0,    34,
       0,    30,     0,    18,     0,    19,     0,    68,     0,    35,
       0,    53,     0,    65,     0,    31,     0,    45,     0,    49,
       0,    69,     0,    39,     0,   152,   135,   153,     0,   153,
       0,   151,   113,   134,     0,    26,   113,     5,     0,   103,
     113,     3,     0,    42,   113,     5,     0,    71,   113,     5,
       0,    69,     0,    22,     0,    62,   113,   164,     0,    51,
     113,     3,     3,     0,    67,   113,   154,     0,    27,   113,
     155,     5,     5,     3,     3,     0,    72,   113,   139,     0,
      76,   113,   148,     0,   147,   149,   147,   150,     0,   147,
     147,     0,   147,   150,     0,   149,   147,     0,   149,   150,
       0,    52,   147,     0,    52,   150,     0,   150,     0,    61,
       0,   147,   149,     0,   147,     0,   149,     0,    52,     0,
       0,   157,   135,   158,     0,   158,     0,   151,   113,   134,
       0,    26,   113,     5,     0,   103,   113,     3,     0,    42,
     113,     5,     0,    71,   113,     5,     0,    70,   113,     5,
       0,    69,     0,    22,     0,    62,   113,   164,     0,    51,
     113,     3,     3,     0,    67,   113,   159,     0,    27,   113,
     160,     5,     5,     3,     3,     0,    72,   113,   139,     0,
      58,   113,   161,     0,   147,   149,   147,   150,     0,   147,
     147,     0,   147,   150,     0,   149,   147,     0,   149,   150,
       0,    52,   147,     0,    52,   150,     0,   150,     0,    61,
       0,   147,   149,     0,   147,     0,   149,     0,    52,     0,
       0,   162,   111,   173,   112,   111,   171,   112,     0,    47,
       0,     0,    25,     0,    23,     0,    33,     0,    28,     0,
     104,     0,    20,     0,    24,     0,     0,   114,     0,   115,
       0,    25,   136,   144,   135,   140,   137,   128,     0,    36,
     136,   144,   135,   141,   135,   138,   137,   128,     0,    23,
     136,   144,   135,   141,   135,   138,   137,   128,     0,    66,
     136,   144,   135,   141,   135,   138,   137,   128,     0,     0,
      63,   167,   136,   169,   137,   128,     0,    51,   136,   144,
     135,   144,   137,   128,     0,    71,   136,   144,   137,   128,
       0,     0,    71,   136,   144,   135,     5,   137,   168,   128,
       0,    67,   136,   144,   135,   144,   137,   128,     0,    27,
     136,   144,   135,   140,   137,   128,     0,    64,   136,   144,
     135,   144,   135,   140,   137,   128,     0,    62,   136,   144,
     137,   128,     0,    25,    62,   136,   144,   137,   128,     0,
      23,    62,   136,   144,   137,   128,     0,    33,    62,   136,
     144,   137,   128,     0,    28,    62,   136,   144,   137,   128,
       0,   104,    62,   136,   144,   137,   128,     0,    20,    62,
     136,   144,   137,   128,     0,    24,    62,   136,   144,   137,
     128,     0,    17,   136,   144,   135,   140,   135,   140,   137,
     128,     0,    17,   136,   144,   135,   140,   135,   140,   135,
     171,   137,   128,     0,    17,   136,   144,   135,   140,   135,
     140,   135,   142,   137,   128,     0,    36,   136,   144,   135,
     141,   135,   141,   135,   138,   137,   128,     0,    36,   136,
     144,   135,   141,   135,   141,   135,   142,   135,   138,   137,
     128,     0,    36,   136,   144,   135,   141,   135,   141,   135,
     175,   135,   138,   137,   128,     0,    36,   136,   144,   135,
     141,   135,   138,   137,   116,   117,    36,   136,   144,   135,
     141,   135,   138,   137,     0,    23,   136,   144,   135,   141,
     135,   141,   135,   138,   137,   128,     0,    23,   136,   144,
     135,   141,   135,   141,   135,   175,   135,   138,   137,   128,
       0,    23,   136,   144,   135,   141,   135,   141,   135,   142,
     135,   138,   137,   128,     0,    23,   136,   144,   135,   141,
     135,   138,   137,   116,   117,    23,   136,   144,   135,   141,
     135,   138,   137,     0,    58,   136,   144,   135,   139,   135,
     139,   135,     3,   135,   140,   135,   140,   135,     3,   137,
     128,     0,    60,   136,   144,   135,   139,   135,   139,   137,
     128,     0,    60,   136,   144,   135,   139,   135,   139,   135,
     173,   137,   128,     0,    60,   136,   144,   135,   139,   135,
     139,   135,   142,   137,   128,     0,    38,   136,   137,   128,
       0,   169,   135,   170,     0,   170,     0,   144,     0,   171,
     135,   172,     0,   172,     0,   140,     0,   173,   135,   174,
       0,   174,     0,   139,     0,   175,   135,   176,     0,   176,
       0,   140,   135,   140,     0,     0
};

#endif

#if YYDEBUG
/* YYRLINE[YYN] -- source line where rule number YYN was defined. */
static const short yyrline[] =
{
       0,   253,   256,   257,   260,   261,   262,   263,   264,   265,
     265,   266,   266,   267,   267,   268,   269,   272,   272,   275,
     276,   276,   279,   280,   280,   282,   283,   283,   287,   288,
     291,   292,   295,   296,   299,   301,   302,   303,   304,   306,
     307,   308,   309,   312,   313,   316,   317,   320,   321,   324,
     325,   328,   329,   330,   333,   334,   335,   336,   337,   338,
     341,   348,   355,   362,   369,   376,   385,   388,   391,   405,
     405,   414,   414,   424,   431,   439,   446,   452,   460,   470,
     471,   472,   473,   474,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,   489,   490,   491,   492,
     493,   494,   495,   496,   497,   498,   499,   500,   501,   502,
     503,   506,   507,   508,   509,   510,   511,   512,   515,   516,
     517,   520,   521,   522,   523,   524,   525,   526,   527,   528,
     531,   532,   535,   540,   545,   546,   551,   556,   561,   566,
     570,   575,   578,   587,   591,   594,   601,   608,   615,   622,
     629,   636,   643,   650,   659,   664,   669,   674,   681,   716,
     717,   720,   721,   722,   723,   724,   725,   726,   727,   729,
     730,   731,   732,   739,   740,   743,   750,   757,   764,   771,
     778,   785,   792,   799,   808,   813,   818,   823,   830,   830,
     831,   834,   868,   869,   870,   871,   872,   873,   874,   877,
     878,   879,   882,   887,   907,   926,   931,   931,   935,   940,
     944,   944,   949,   955,   962,   970,  1010,  1014,  1018,  1022,
    1026,  1030,  1034,  1039,  1043,  1052,  1057,  1065,  1074,  1085,
    1093,  1101,  1111,  1121,  1129,  1148,  1149,  1150,  1151,  1154,
    1155,  1158,  1161,  1162,  1165,  1172,  1173,  1176,  1183,  1184,
    1187,  1190
};
#endif


#if (YYDEBUG) || defined YYERROR_VERBOSE

/* YYTNAME[TOKEN_NUM] -- String name of the token TOKEN_NUM. */
static const char *const yytname[] =
{
  "$", "error", "$undefined.", "INT", "REAL", "STRING", "HOUR", "MINUTE", 
  "SECOND", "DEGREE", "ARCMINUTE", "ARCSECOND", "RADIAN", "PHYCOORD", 
  "IMGCOORD", "SEXSTR", "AMPLIFIER_", "ANNULUS_", "ARCMIN_", "ARCSEC_", 
  "ARROW_", "B1950_", "BACKGROUND_", "BOX_", "BOXCIRCLE_", "CIRCLE_", 
  "COLOR_", "COMPASS_", "CROSS_", "DEBUG_", "DEGREES_", "DELETE_", 
  "DETECTOR_", "DIAMOND_", "ECLIPTIC_", "EDIT_", "ELLIPSE_", "FALSE_", 
  "FIELD_", "FIXED_", "FK4_", "FK5_", "FONT_", "GALACTIC_", "GLOBAL_", 
  "HIGHLITE_", "ICRS_", "IGNORE_", "IMAGE_", "INCLUDE_", "J2000_", 
  "LINE_", "LINEAR_", "MOVE_", "N_", "NO_", "OFF_", "ON_", "PANDA_", 
  "PHYSICAL_", "PIE_", "PIXELS_", "POINT_", "POLYGON_", "PROJECTION_", 
  "ROTATE_", "ROTBOX_", "RULER_", "SELECT_", "SOURCE_", "TAG_", "TEXT_", 
  "TEXTANGLE_", "TILE_", "TRUE_", "VERSION_", "WCS_", "WCSA_", "WCSB_", 
  "WCSC_", "WCSD_", "WCSE_", "WCSF_", "WCSG_", "WCSH_", "WCSI_", "WCSJ_", 
  "WCSK_", "WCSL_", "WCSM_", "WCSN_", "WCSO_", "WCSP_", "WCSQ_", "WCSR_", 
  "WCSS_", "WCST_", "WCSU_", "WCSV_", "WCSW_", "WCSX_", "WCSY_", "WCSZ_", 
  "WIDTH_", "X_", "Y_", "YES_", "'#'", "'\\n'", "';'", "','", "'('", 
  "')'", "'='", "'+'", "'-'", "'&'", "'!'", "start", "commands", 
  "command", "@1", "@2", "@3", "generalComment", "@4", "comment", "@5", 
  "shapeComment", "@6", "@7", "terminator", "numeric", "debug", "yesno", 
  "sp", "bp", "ep", "optangle", "angle", "value", "vvalue", "numberof", 
  "sexagesimal", "coord", "@8", "@9", "coordSystem", "wcsSystem", 
  "skyFrame", "skyFormat", "property", "global", "globalProperty", 
  "globalRuler", "globalCompass", "initGlobal", "local", "localProperty", 
  "localRuler", "localCompass", "localPanda", "@10", "initLocal", 
  "pointProp", "include", "shape", "@11", "@12", "polyNodes", "polyNode", 
  "aRads", "aRad", "aAngs", "aAng", "vRads", "vRad", "postLocal", 0
};
#endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives. */
static const short yyr1[] =
{
       0,   118,   119,   119,   120,   120,   120,   120,   120,   121,
     120,   122,   120,   123,   120,   120,   120,   125,   124,   126,
     127,   126,   128,   129,   128,   128,   130,   128,   131,   131,
     132,   132,   133,   133,   134,   134,   134,   134,   134,   134,
     134,   134,   134,   135,   135,   136,   136,   137,   137,   138,
     138,   139,   139,   139,   140,   140,   140,   140,   140,   140,
     141,   141,   141,   141,   141,   141,   142,   143,   144,   145,
     144,   146,   144,   144,   144,   144,   144,   144,   144,   147,
     147,   147,   147,   147,   148,   148,   148,   148,   148,   148,
     148,   148,   148,   148,   148,   148,   148,   148,   148,   148,
     148,   148,   148,   148,   148,   148,   148,   148,   148,   148,
     148,   149,   149,   149,   149,   149,   149,   149,   150,   150,
     150,   151,   151,   151,   151,   151,   151,   151,   151,   151,
     152,   152,   153,   153,   153,   153,   153,   153,   153,   153,
     153,   153,   153,   153,   153,   154,   154,   154,   154,   154,
     154,   154,   154,   154,   155,   155,   155,   155,   156,   157,
     157,   158,   158,   158,   158,   158,   158,   158,   158,   158,
     158,   158,   158,   158,   158,   159,   159,   159,   159,   159,
     159,   159,   159,   159,   160,   160,   160,   160,   162,   161,
     161,   163,   164,   164,   164,   164,   164,   164,   164,   165,
     165,   165,   166,   166,   166,   166,   167,   166,   166,   166,
     168,   166,   166,   166,   166,   166,   166,   166,   166,   166,
     166,   166,   166,   166,   166,   166,   166,   166,   166,   166,
     166,   166,   166,   166,   166,   166,   166,   166,   166,   169,
     169,   170,   171,   171,   172,   173,   173,   174,   175,   175,
     176,   177
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN. */
static const short yyr2[] =
{
       0,     3,     3,     2,     0,     2,     1,     3,     2,     0,
       3,     0,     3,     0,     3,     3,     1,     0,     3,     0,
       0,     3,     1,     0,     4,     3,     0,     5,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     0,     1,     0,     1,     0,     1,     0,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     3,     3,     3,     3,     3,     3,     1,     3,     0,
       8,     0,     8,     3,     3,     3,     3,     3,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     1,     3,     3,     3,     3,     3,     1,     1,     3,
       4,     3,     7,     3,     3,     4,     2,     2,     2,     2,
       2,     2,     1,     1,     2,     1,     1,     1,     0,     3,
       1,     3,     3,     3,     3,     3,     3,     1,     1,     3,
       4,     3,     7,     3,     3,     4,     2,     2,     2,     2,
       2,     2,     1,     1,     2,     1,     1,     1,     0,     7,
       1,     0,     1,     1,     1,     1,     1,     1,     1,     0,
       1,     1,     7,     9,     9,     9,     0,     6,     7,     5,
       0,     8,     7,     7,     9,     5,     6,     6,     6,     6,
       6,     6,     6,     9,    11,    11,    11,    13,    13,    18,
      11,    13,    13,    18,    17,     9,    11,    11,     4,     3,
       1,     1,     3,     1,     1,     3,     1,     1,     3,     1,
       3,     0
};

/* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
   doesn't specify something else to do.  Zero means the default is an
   error. */
static const short yydefact[] =
{
     158,   191,    82,   112,     0,    81,   117,   111,   113,   116,
       0,   115,    79,   114,    13,    80,     0,     6,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,    17,   191,     0,    16,     9,
      83,    11,   199,    33,    32,     5,   138,     0,     0,   125,
     122,   129,     0,   126,   127,     0,   123,     0,   124,     0,
     121,   137,     0,     0,     0,     0,     0,    43,   131,    19,
       8,     0,     0,     1,    28,    29,     3,    19,    19,   200,
     201,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    20,    44,     7,     0,    14,    18,     2,
      10,    12,    45,     0,    45,     0,    45,    45,     0,     0,
      45,    45,    45,    45,    45,    45,   206,    45,    45,    45,
      45,     0,    15,   133,   157,   155,   156,     0,   135,     0,
     197,   193,   198,   192,   195,   194,   196,   139,   119,   120,
     118,     0,   153,     0,     0,   152,   141,   136,    31,    30,
      52,    53,    51,   143,   144,   134,    34,    42,    40,    39,
      41,    37,    38,    36,    35,   132,     0,   130,    46,     0,
      45,    45,     0,    45,    45,     0,     0,    45,    45,     0,
      47,     0,     0,     0,     0,    45,     0,     0,     0,     0,
      45,   154,     0,   140,   150,   151,   146,     0,   147,   148,
     149,    21,    31,     0,    43,    43,    43,    67,    43,    43,
      43,     0,     0,    43,     0,     0,    43,    43,     0,     0,
      43,    48,   251,    43,    43,    43,    47,     0,    43,    43,
      43,    47,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    47,    47,     0,    47,    47,     0,     0,
      47,    47,     0,    23,   238,    22,     0,     0,     0,   251,
     241,    43,   240,     0,     0,     0,     0,   251,    47,     0,
     145,    71,    69,    74,    76,    78,    77,    75,    73,    68,
      57,    58,    59,    55,    56,    54,    43,   251,   251,    43,
      43,    43,    43,    43,    43,    43,   251,   251,    47,    47,
     251,   251,    43,   168,     0,     0,     0,     0,     0,     0,
       0,   167,     0,     0,     0,     0,     0,     0,    43,   160,
      47,    43,    43,   215,     0,   251,    43,    43,    47,    47,
     209,   251,   142,    43,    43,     0,   221,   217,     0,     0,
       0,     0,     0,     0,    49,   222,   216,   251,   251,   219,
     218,    49,     0,     0,     0,     0,   188,     0,     0,     0,
       0,     0,     0,   251,     0,     0,     0,    25,   251,     0,
       0,   239,   207,     0,    49,   251,   210,   220,     0,     0,
      43,    63,    64,    65,    61,    62,    60,    52,    51,    47,
      50,    43,   202,   213,    47,    43,   162,   187,   185,   186,
       0,   164,     0,   190,   174,     0,   169,     0,   183,     0,
       0,   182,   171,   166,   165,   173,   163,    24,   161,   251,
     159,   208,    43,    43,    47,    47,   212,   251,     0,     0,
       0,   251,   251,    49,   251,    49,   184,     0,   170,     0,
     180,   181,   176,     0,   177,   178,   179,    27,     0,     0,
     251,   251,   251,   211,     0,     0,     0,   244,    47,    43,
     243,   223,     0,   204,    57,    54,    47,    43,    43,    43,
     249,     0,   203,    47,    43,    43,     0,   247,    43,   246,
       0,    43,    47,    43,   235,   214,   205,    72,    70,     0,
     251,     0,   251,     0,   251,     0,    49,    49,     0,   251,
      49,    49,     0,     0,     0,   175,     0,   251,   251,    66,
     225,   242,   224,    45,   230,   250,    47,    47,   248,    45,
     226,    47,    47,   172,     0,   245,    43,   237,   236,     0,
     251,   251,     0,   251,   251,    43,     0,    43,   232,   231,
      43,   227,   228,   189,    43,     0,     0,     0,    43,    43,
      47,    49,    49,   251,    47,    47,   234,   233,   229,     0,
       0,     0
};

static const short yydefgoto[] =
{
     569,    46,    47,    87,    88,    79,    48,    81,   105,   176,
     264,   326,   375,    86,   218,    55,   175,   348,   179,   232,
     399,   400,   477,   305,   468,   219,   270,   344,   343,    49,
      50,    51,   155,    76,    77,    78,   156,   137,     1,   328,
     329,   422,   410,   414,   415,    52,   147,    91,   132,   195,
     437,   271,   272,   469,   470,   488,   489,   479,   480,   265
};

static const short yypact[] =
{
  -32768,   830,-32768,-32768,    61,-32768,-32768,-32768,-32768,-32768,
    1440,-32768,-32768,-32768,-32768,-32768,     4,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,   741,    43,-32768,-32768,
  -32768,-32768,    40,-32768,-32768,-32768,-32768,   -88,   -81,-32768,
  -32768,-32768,   -73,-32768,-32768,   -69,-32768,   -61,-32768,   -51,
  -32768,   -30,   -25,   -20,   -15,   -12,    -9,   132,-32768,   -32,
  -32768,   110,    43,-32768,-32768,-32768,-32768,   -32,   -32,-32768,
  -32768,   545,   116,  1185,   131,   137,   187,   924,   139,    54,
    1468,   176,    71,-32768,-32768,-32768,  1440,-32768,-32768,-32768,
  -32768,-32768,    73,   123,   -31,   126,   -21,    73,   127,   129,
      73,    73,    73,    73,    73,    73,-32768,    73,    73,    73,
      73,   130,-32768,-32768,-32768,   229,-32768,   188,-32768,   194,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,   623,-32768,  1098,   623,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,   196,-32768,-32768,   497,
      73,    73,   497,    73,    73,   497,   497,    73,    73,   497,
      88,   497,   497,   497,   497,    73,   497,   497,   497,   497,
      73,-32768,   198,-32768,-32768,-32768,-32768,  1359,-32768,-32768,
  -32768,-32768,   203,   207,   112,   112,   112,-32768,   112,   112,
     112,   497,   497,   112,   497,   497,   112,   112,   497,   497,
     112,-32768,   140,   112,   112,   112,    88,   497,   112,   112,
     112,    -3,   497,   243,    41,   237,   244,   247,   146,   161,
     178,   238,   316,    88,    88,   541,    88,    88,   316,   316,
      88,    88,   541,  1361,-32768,-32768,   497,    54,    54,   140,
  -32768,    58,-32768,   497,   541,   497,   252,   140,    88,   255,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,   112,   140,   140,   112,
     112,   112,   112,   112,   112,   112,   140,   140,    88,    88,
     140,   140,   112,-32768,   148,   149,   151,   152,   155,   158,
     164,   -30,   165,   167,   170,   173,   269,   180,    25,-32768,
      88,   112,   112,-32768,   497,   140,   112,   112,    88,    88,
  -32768,   140,-32768,   112,   112,   316,-32768,-32768,   287,   288,
     286,   289,   291,   178,   371,-32768,-32768,   140,   140,-32768,
  -32768,   371,   295,  1272,   296,   300,   259,   187,  1011,   305,
     311,    54,   314,-32768,    71,   313,  1361,-32768,   140,    54,
      54,-32768,-32768,   316,    54,   140,-32768,-32768,   319,   320,
      58,-32768,-32768,-32768,-32768,-32768,-32768,     6,    19,    88,
  -32768,   112,-32768,-32768,    88,   112,-32768,-32768,   229,-32768,
     327,-32768,   330,-32768,-32768,   225,-32768,   623,-32768,  1098,
     623,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,   112,    58,    88,    88,-32768,   140,   331,   332,
     195,   140,   -16,   334,    15,   334,-32768,   335,-32768,    54,
  -32768,-32768,-32768,  1359,-32768,-32768,-32768,-32768,   346,    93,
     140,   140,   140,-32768,   339,   340,   239,-32768,    88,    58,
  -32768,-32768,   240,-32768,   109,   122,    88,   112,   112,   112,
  -32768,   242,-32768,    88,   112,   112,   350,-32768,   -75,-32768,
      41,   112,    88,    58,-32768,-32768,-32768,-32768,-32768,   359,
     140,   316,   140,   343,   140,   316,    54,   512,   336,   140,
      54,   512,   360,   256,    54,-32768,   316,   140,   140,-32768,
  -32768,-32768,-32768,    73,-32768,-32768,    88,    88,-32768,    73,
  -32768,    88,    88,-32768,   316,-32768,   112,-32768,-32768,   497,
     140,   140,   497,   140,   140,   -45,   316,   112,-32768,-32768,
     112,-32768,-32768,-32768,   112,   541,   541,   367,   112,   112,
      88,    54,    54,   140,    88,    88,-32768,-32768,-32768,   376,
     378,-32768
};

static const short yypgoto[] =
{
  -32768,-32768,   347,-32768,-32768,-32768,-32768,-32768,    24,-32768,
     236,-32768,-32768,   304,   -72,-32768,    21,   -77,  -111,   200,
    -274,   -95,   -14,  -241,  -398,   138,  -143,-32768,-32768,   -59,
     297,   -29,  -125,  -262,-32768,   292,-32768,-32768,-32768,-32768,
      27,-32768,-32768,-32768,-32768,-32768,    37,-32768,-32768,-32768,
  -32768,-32768,    72,  -129,   -92,   -49,  -101,   -28,  -487,   -38
};


#define	YYLAST		1570


static const short yytable[] =
{
     106,   327,   -43,   182,   163,   185,   186,    80,    83,   189,
     190,   191,   192,   193,   194,   -43,   196,   197,   198,   199,
     528,   312,   -43,   -43,   528,    92,   205,   162,   208,   210,
     -26,   181,    93,   337,   135,   104,   220,   513,   153,   223,
      94,   184,   226,   227,    95,   478,   230,   484,   233,   234,
     235,   236,    96,   238,   239,   240,   241,   158,   159,   148,
     149,   492,    97,   160,   136,   104,   161,   553,   154,   221,
     222,   150,   224,   225,   166,   103,   228,   229,   253,   254,
     178,   256,   257,  -128,   237,   260,   261,   404,    98,   242,
     178,   263,   204,    99,   206,   209,   158,   159,   100,   278,
     472,   101,   160,   107,   102,   161,   201,   104,   167,   231,
     435,   110,   111,   401,   327,   108,   104,    53,    54,   280,
     405,   133,   263,   330,   207,   168,   169,   170,   171,   104,
     336,   481,   338,  -251,  -251,   104,   138,   247,   248,   249,
     139,   250,   251,   252,   157,   172,   255,   466,   244,   258,
     259,    84,    85,   262,    89,    90,   266,   267,   268,   284,
     285,   273,   274,   275,   276,   -47,   -47,   -47,   104,   476,
     231,   483,   331,   332,   286,   287,   173,   174,   288,   165,
     295,   158,   159,   304,   178,   180,   295,   295,   183,   187,
     304,   188,   200,   202,   334,   162,   162,   203,   158,   159,
     231,   211,   304,   243,   290,   291,   292,   140,   293,   294,
     141,   142,   143,   245,   246,   144,   -52,   -52,   -52,   345,
     145,   -52,   104,   349,   350,   351,   352,   353,   354,   -51,
     -51,   -51,   526,   527,   -51,   361,   531,   532,   296,   103,
     -19,   -19,   104,   421,   308,   309,   279,   263,   281,   466,
       3,   376,   282,   217,   379,   380,   283,   339,   342,   383,
     384,   362,   363,     6,   364,   365,   388,   389,   366,     7,
       8,   367,     9,   295,   373,    11,   425,   368,   369,    13,
     370,   396,   398,   371,   432,   433,   372,   564,   565,   398,
     377,   146,   451,   374,   454,   456,   391,   393,   392,   162,
     406,   411,   394,   412,   408,   395,   413,   162,   162,   419,
     423,   295,   162,   440,   558,   559,   424,   426,   429,   158,
     159,   353,   438,   439,   443,   290,   291,   292,   445,   293,
     294,   390,   447,   448,   409,   427,   449,   158,   159,   420,
     486,   464,   465,   474,   291,   292,   161,   293,   294,   491,
     497,   498,   499,   512,   487,   458,   459,   503,   450,   508,
     452,   455,   519,   533,   487,   515,   523,   534,   295,   434,
     560,   475,   529,   475,   158,   159,   570,   162,   571,   446,
     397,   300,   301,   161,   302,   303,   109,   162,   466,   289,
     453,   457,   501,    82,   490,   428,   547,   164,   177,   550,
     505,   506,   507,   430,   416,   545,   381,   510,   511,   521,
     493,   514,   539,   535,   516,     0,   514,   485,   542,   487,
       0,     0,     0,     0,     0,     0,   467,     0,     0,   295,
       0,     0,     0,   295,   162,   475,   269,     0,   162,   475,
       0,   277,   162,     0,   295,     0,     0,     0,     0,     0,
       0,     0,     0,   297,   298,     0,   306,   307,     0,   546,
     310,   311,   295,     0,     0,     0,     0,     0,   501,     0,
     555,   335,     0,   556,   295,     0,     0,   557,   341,     0,
       0,   561,   562,   304,   304,     0,     0,   467,     0,   162,
     162,   525,     0,     0,     0,     0,     0,     0,     0,     0,
     212,   159,   536,   213,     0,   333,   214,     0,   357,   358,
     215,   216,   217,   340,     0,   158,   159,     0,     0,     0,
     467,   474,   291,   292,   161,   293,   294,     0,     0,     0,
     378,     0,   554,   346,   347,     0,     0,     0,   385,   386,
       0,     0,   355,   356,   158,   159,   359,   360,     0,     0,
     299,   300,   301,     0,   302,   303,     0,     0,     0,     0,
       0,     0,   112,     0,     0,   113,     0,     0,   114,   115,
     116,   382,   117,   118,     0,     0,     0,   387,   119,     0,
       0,   120,     0,   121,     0,     0,     0,     0,     0,     0,
     441,     0,     0,   402,   403,     0,   122,     0,     0,   442,
       0,     0,     0,   123,   444,   124,     0,   125,   126,   127,
       0,   128,   129,     0,   431,     0,   130,     0,     0,     0,
       0,   436,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   460,   461,   462,     0,     0,     0,     2,
       0,   148,   149,     0,     0,     0,     0,     0,     0,   131,
       0,     0,     0,   150,     0,     5,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   500,   502,
       0,    12,     0,   463,     0,     0,   504,   471,   473,     0,
     482,     0,    15,   509,     0,     0,     0,     0,     0,     0,
       0,     0,   517,   518,     0,     0,   494,   495,   496,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,   540,   541,     0,     0,
       0,   543,   544,     0,     0,     0,   520,     0,   522,     0,
     524,  -251,     0,     0,     0,   530,     0,     0,     0,     0,
       0,     0,     0,   537,   538,     0,     0,     2,     0,     0,
     563,     0,     3,     0,   567,   568,     0,     0,     0,     0,
       4,     0,     0,     5,     0,     6,   548,   549,     0,   551,
     552,     7,     8,     0,     9,    10,     0,    11,     0,    12,
       0,    13,     0,    14,     0,     0,     0,     0,     0,   566,
      15,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    16,     0,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,     0,     0,     2,     0,    45,    -4,
      -4,     3,     0,     0,     0,     0,     0,     0,     0,     4,
       0,     0,     5,     0,     6,     0,     0,     0,     0,     0,
       7,     8,     0,     9,    10,     0,    11,     0,    12,     0,
      13,     0,    14,     0,     0,     0,     0,     0,     0,    15,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    16,     0,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,     0,     0,     0,     0,    45,    -4,    -4,
       2,     0,   148,   149,     0,     3,     0,     0,     0,     0,
       0,     0,     0,     0,   150,     0,     5,     0,     6,     0,
       0,     0,     0,     0,     7,     8,     0,     9,     0,     0,
      11,     0,    12,     0,    13,     0,   151,     0,     0,     0,
       0,     0,     0,    15,     0,   152,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,     2,     0,   148,
     149,     0,     3,     0,     0,     0,     0,     0,     0,     0,
       0,   150,     0,     5,     0,     6,     0,     0,     0,     0,
       0,     7,     8,     0,     9,     0,     0,    11,     0,    12,
       0,    13,     0,   417,     0,     0,     0,     0,     0,     0,
      15,     0,   418,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,     2,     0,   148,   149,     0,     3,
       0,     0,     0,     0,     0,     0,     0,     0,   150,     0,
       5,     0,     6,     0,     0,     0,     0,     0,     7,     8,
       0,     9,     0,     0,    11,     0,    12,     0,    13,     0,
       0,     0,     0,     0,     0,     0,     0,    15,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,     2,     0,     0,     0,     0,     3,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     5,     0,     6,
       0,     0,     0,     0,     0,     7,     8,     0,     9,     0,
       0,    11,     0,    12,     0,    13,     0,   134,     0,     0,
       0,     0,     0,     0,    15,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,     2,     0,
       0,     0,     0,     3,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     5,     0,     6,     0,     0,     0,
       0,     0,     7,     8,     0,     9,     0,     0,    11,     0,
      12,     0,    13,     0,   407,     0,     0,     0,     0,     0,
       0,    15,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,     2,     0,     0,     0,     0,
       0,     0,     0,   313,     0,     0,     0,   314,   315,     0,
       0,     5,    59,     0,     0,     0,    60,     0,     0,     0,
      61,     0,     0,   316,     0,     0,    63,    12,     0,     0,
      64,     0,   317,     0,    66,     0,     0,     0,    15,   318,
       0,     0,     0,   319,     0,     0,    68,     0,   320,    70,
     321,   322,   323,   324,     0,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    56,     0,   325,     0,    57,    58,     0,     0,
       0,    59,     0,     0,     0,    60,     0,     0,     0,    61,
       0,     0,    62,     0,     0,    63,     0,     0,     0,    64,
       0,    65,     0,    66,     0,     0,     0,     0,     0,     0,
       0,     0,    67,     0,     0,    68,     0,    69,    70,    71,
       0,    72,    73,     0,     0,     0,    74,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    75,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44
};

static const short yycheck[] =
{
      77,   263,     5,   114,    99,   116,   117,     3,    46,   120,
     121,   122,   123,   124,   125,     9,   127,   128,   129,   130,
     507,   262,     3,     4,   511,   113,   151,    99,   153,   154,
       5,    62,   113,   274,    93,   110,   179,   112,    97,   182,
     113,    62,   185,   186,   113,   443,   189,   445,   191,   192,
     193,   194,   113,   196,   197,   198,   199,     3,     4,    18,
      19,   459,   113,     9,    93,   110,    12,   112,    97,   180,
     181,    30,   183,   184,     3,   107,   187,   188,   221,   222,
     111,   224,   225,   113,   195,   228,   229,   361,   113,   200,
     111,   107,   151,   113,   153,   154,     3,     4,   113,   242,
     116,   113,     9,    79,   113,    12,   135,   110,    37,   112,
     384,    87,    88,   354,   376,     5,   110,    56,    57,   244,
     361,     5,   107,   266,   153,    54,    55,    56,    57,   110,
     273,   116,   275,   108,   109,   110,     5,   214,   215,   216,
       3,   218,   219,   220,     5,    74,   223,    54,   207,   226,
     227,   108,   109,   230,   114,   115,   233,   234,   235,    13,
      14,   238,   239,   240,   241,   107,   108,   109,   110,   443,
     112,   445,   267,   268,    13,    14,   105,   106,   250,     3,
     252,     3,     4,   255,   111,    62,   258,   259,    62,    62,
     262,    62,    62,     5,   271,   267,   268,     3,     3,     4,
     112,     5,   274,     5,     9,    10,    11,    20,    13,    14,
      23,    24,    25,    10,     7,    28,   107,   108,   109,   296,
      33,   112,   110,   300,   301,   302,   303,   304,   305,   107,
     108,   109,   506,   507,   112,   312,   510,   511,   252,   107,
     108,   109,   110,   368,   258,   259,     3,   107,    11,    54,
      21,   328,     8,    15,   331,   332,     9,     5,     3,   336,
     337,   113,   113,    34,   113,   113,   343,   344,   113,    40,
      41,   113,    43,   345,     5,    46,   371,   113,   113,    50,
     113,   353,   354,   113,   379,   380,   113,   561,   562,   361,
     328,   104,   417,   113,   419,   420,     9,    11,    10,   371,
       5,     5,    13,     3,   363,    14,    47,   379,   380,   368,
       5,   383,   384,   390,   555,   556,     5,     3,     5,     3,
       4,   398,     3,     3,   401,     9,    10,    11,   405,    13,
      14,   345,     5,     3,   363,   373,   111,     3,     4,   368,
       5,    10,    10,     9,    10,    11,    12,    13,    14,     3,
      11,    11,   113,     3,   449,   432,   433,   117,   417,   117,
     419,   420,     3,     3,   459,   490,    23,   111,   440,   383,
       3,   443,    36,   445,     3,     4,     0,   449,     0,   408,
       9,    10,    11,    12,    13,    14,    82,   459,    54,   251,
     419,   429,   469,    46,   453,   374,   539,   100,   106,   542,
     477,   478,   479,   376,   367,   534,   334,   484,   485,   501,
     459,   488,   523,   514,   491,    -1,   493,   445,   529,   514,
      -1,    -1,    -1,    -1,    -1,    -1,   440,    -1,    -1,   501,
      -1,    -1,    -1,   505,   506,   507,   236,    -1,   510,   511,
      -1,   241,   514,    -1,   516,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   253,   254,    -1,   256,   257,    -1,   536,
     260,   261,   534,    -1,    -1,    -1,    -1,    -1,   545,    -1,
     547,   271,    -1,   550,   546,    -1,    -1,   554,   278,    -1,
      -1,   558,   559,   555,   556,    -1,    -1,   501,    -1,   561,
     562,   505,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       3,     4,   516,     6,    -1,   269,     9,    -1,   308,   309,
      13,    14,    15,   277,    -1,     3,     4,    -1,    -1,    -1,
     534,     9,    10,    11,    12,    13,    14,    -1,    -1,    -1,
     330,    -1,   546,   297,   298,    -1,    -1,    -1,   338,   339,
      -1,    -1,   306,   307,     3,     4,   310,   311,    -1,    -1,
       9,    10,    11,    -1,    13,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    17,    -1,    -1,    20,    -1,    -1,    23,    24,
      25,   335,    27,    28,    -1,    -1,    -1,   341,    33,    -1,
      -1,    36,    -1,    38,    -1,    -1,    -1,    -1,    -1,    -1,
     390,    -1,    -1,   357,   358,    -1,    51,    -1,    -1,   399,
      -1,    -1,    -1,    58,   404,    60,    -1,    62,    63,    64,
      -1,    66,    67,    -1,   378,    -1,    71,    -1,    -1,    -1,
      -1,   385,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   433,   434,   435,    -1,    -1,    -1,    16,
      -1,    18,    19,    -1,    -1,    -1,    -1,    -1,    -1,   104,
      -1,    -1,    -1,    30,    -1,    32,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   468,   469,
      -1,    48,    -1,   437,    -1,    -1,   476,   441,   442,    -1,
     444,    -1,    59,   483,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   492,   493,    -1,    -1,   460,   461,   462,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   526,   527,    -1,    -1,
      -1,   531,   532,    -1,    -1,    -1,   500,    -1,   502,    -1,
     504,     0,    -1,    -1,    -1,   509,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   517,   518,    -1,    -1,    16,    -1,    -1,
     560,    -1,    21,    -1,   564,   565,    -1,    -1,    -1,    -1,
      29,    -1,    -1,    32,    -1,    34,   540,   541,    -1,   543,
     544,    40,    41,    -1,    43,    44,    -1,    46,    -1,    48,
      -1,    50,    -1,    52,    -1,    -1,    -1,    -1,    -1,   563,
      59,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    73,    -1,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    -1,    -1,    16,    -1,   107,   108,
     109,    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    29,
      -1,    -1,    32,    -1,    34,    -1,    -1,    -1,    -1,    -1,
      40,    41,    -1,    43,    44,    -1,    46,    -1,    48,    -1,
      50,    -1,    52,    -1,    -1,    -1,    -1,    -1,    -1,    59,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    73,    -1,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,    -1,    -1,    -1,    -1,   107,   108,   109,
      16,    -1,    18,    19,    -1,    21,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    30,    -1,    32,    -1,    34,    -1,
      -1,    -1,    -1,    -1,    40,    41,    -1,    43,    -1,    -1,
      46,    -1,    48,    -1,    50,    -1,    52,    -1,    -1,    -1,
      -1,    -1,    -1,    59,    -1,    61,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,    16,    -1,    18,
      19,    -1,    21,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    30,    -1,    32,    -1,    34,    -1,    -1,    -1,    -1,
      -1,    40,    41,    -1,    43,    -1,    -1,    46,    -1,    48,
      -1,    50,    -1,    52,    -1,    -1,    -1,    -1,    -1,    -1,
      59,    -1,    61,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,    16,    -1,    18,    19,    -1,    21,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    30,    -1,
      32,    -1,    34,    -1,    -1,    -1,    -1,    -1,    40,    41,
      -1,    43,    -1,    -1,    46,    -1,    48,    -1,    50,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    59,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,    16,    -1,    -1,    -1,    -1,    21,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    32,    -1,    34,
      -1,    -1,    -1,    -1,    -1,    40,    41,    -1,    43,    -1,
      -1,    46,    -1,    48,    -1,    50,    -1,    52,    -1,    -1,
      -1,    -1,    -1,    -1,    59,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,    16,    -1,
      -1,    -1,    -1,    21,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    32,    -1,    34,    -1,    -1,    -1,
      -1,    -1,    40,    41,    -1,    43,    -1,    -1,    46,    -1,
      48,    -1,    50,    -1,    52,    -1,    -1,    -1,    -1,    -1,
      -1,    59,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,    16,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    -1,    -1,    -1,    26,    27,    -1,
      -1,    32,    31,    -1,    -1,    -1,    35,    -1,    -1,    -1,
      39,    -1,    -1,    42,    -1,    -1,    45,    48,    -1,    -1,
      49,    -1,    51,    -1,    53,    -1,    -1,    -1,    59,    58,
      -1,    -1,    -1,    62,    -1,    -1,    65,    -1,    67,    68,
      69,    70,    71,    72,    -1,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,    22,    -1,   103,    -1,    26,    27,    -1,    -1,
      -1,    31,    -1,    -1,    -1,    35,    -1,    -1,    -1,    39,
      -1,    -1,    42,    -1,    -1,    45,    -1,    -1,    -1,    49,
      -1,    51,    -1,    53,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    62,    -1,    -1,    65,    -1,    67,    68,    69,
      -1,    71,    72,    -1,    -1,    -1,    76,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   103,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison/bison.simple"

/* Skeleton output parser for bison,

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software
   Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser when
   the %semantic_parser declaration is not specified in the grammar.
   It was written by Richard Stallman by simplifying the hairy parser
   used when %semantic_parser is specified.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

#if ! defined (yyoverflow) || defined (YYERROR_VERBOSE)

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || defined (YYERROR_VERBOSE) */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYLTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
# if YYLSP_NEEDED
  YYLTYPE yyls;
# endif
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAX (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# if YYLSP_NEEDED
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE) + sizeof (YYLTYPE))	\
      + 2 * YYSTACK_GAP_MAX)
# else
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAX)
# endif

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAX;	\
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif


#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");			\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).

   When YYLLOC_DEFAULT is run, CURRENT is set the location of the
   first token.  By default, to implement support for ranges, extend
   its range to the last symbol.  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)       	\
   Current.last_line   = Rhs[N].last_line;	\
   Current.last_column = Rhs[N].last_column;
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#if YYPURE
# if YYLSP_NEEDED
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, &yylloc, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval, &yylloc)
#  endif
# else /* !YYLSP_NEEDED */
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval)
#  endif
# endif /* !YYLSP_NEEDED */
#else /* !YYPURE */
# define YYLEX			yylex ()
#endif /* !YYPURE */


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)
/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif

#ifdef YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif
#endif

#line 315 "/usr/share/bison/bison.simple"


/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
#  define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL
# else
#  define YYPARSE_PARAM_ARG YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
# endif
#else /* !YYPARSE_PARAM */
# define YYPARSE_PARAM_ARG
# define YYPARSE_PARAM_DECL
#endif /* !YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
# ifdef YYPARSE_PARAM
int yyparse (void *);
# else
int yyparse (void);
# endif
#endif

/* YY_DECL_VARIABLES -- depending whether we use a pure parser,
   variables are global, or local to YYPARSE.  */

#define YY_DECL_NON_LSP_VARIABLES			\
/* The lookahead symbol.  */				\
int yychar;						\
							\
/* The semantic value of the lookahead symbol. */	\
YYSTYPE yylval;						\
							\
/* Number of parse errors so far.  */			\
int yynerrs;

#if YYLSP_NEEDED
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES			\
						\
/* Location data for the lookahead symbol.  */	\
YYLTYPE yylloc;
#else
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES
#endif


/* If nonreentrant, generate the variables here. */

#if !YYPURE
YY_DECL_VARIABLES
#endif  /* !YYPURE */

int
yyparse (YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  /* If reentrant, generate the variables here. */
#if YYPURE
  YY_DECL_VARIABLES
#endif  /* !YYPURE */

  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yychar1 = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack. */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;

#if YYLSP_NEEDED
  /* The location stack.  */
  YYLTYPE yylsa[YYINITDEPTH];
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
#endif

#if YYLSP_NEEDED
# define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
# define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  YYSIZE_T yystacksize = YYINITDEPTH;


  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
#if YYLSP_NEEDED
  YYLTYPE yyloc;
#endif

  /* When reducing, the number of symbols on the RHS of the reduced
     rule. */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;
#if YYLSP_NEEDED
  yylsp = yyls;
#endif
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  */
# if YYLSP_NEEDED
	YYLTYPE *yyls1 = yyls;
	/* This used to be a conditional around just the two extra args,
	   but that might be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);
	yyls = yyls1;
# else
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);
# endif
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);
# if YYLSP_NEEDED
	YYSTACK_RELOCATE (yyls);
# endif
# undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
#if YYLSP_NEEDED
      yylsp = yyls + yysize - 1;
#endif

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yychar1 = YYTRANSLATE (yychar);

#if YYDEBUG
     /* We have to keep this `#if YYDEBUG', since we use variables
	which are defined only if `YYDEBUG' is set.  */
      if (yydebug)
	{
	  YYFPRINTF (stderr, "Next token is %d (%s",
		     yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise
	     meaning of a token, for further debugging info.  */
# ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
# endif
	  YYFPRINTF (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %d (%s), ",
	      yychar, yytname[yychar1]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to the semantic value of
     the lookahead token.  This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

#if YYLSP_NEEDED
  /* Similarly for the default location.  Let the user run additional
     commands if for instance locations are ranges.  */
  yyloc = yylsp[1-yylen];
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
#endif

#if YYDEBUG
  /* We have to keep this `#if YYDEBUG', since we use variables which
     are defined only if `YYDEBUG' is set.  */
  if (yydebug)
    {
      int yyi;

      YYFPRINTF (stderr, "Reducing via rule %d (line %d), ",
		 yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (yyi = yyprhs[yyn]; yyrhs[yyi] > 0; yyi++)
	YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
      YYFPRINTF (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif

  switch (yyn) {

case 6:
#line 262 "ds9parser.Y"
{cerr << "DS9 Regions File 3.0" << endl;;
    break;}
case 8:
#line 264 "ds9parser.Y"
{globalTile = yyvsp[0].integer;;
    break;}
case 9:
#line 265 "ds9parser.Y"
{globalSystem = (CoordSystem)yyvsp[0].integer;;
    break;}
case 11:
#line 266 "ds9parser.Y"
{globalSystem = WCS; globalSky = (SkyFrame)yyvsp[0].integer;;
    break;}
case 13:
#line 267 "ds9parser.Y"
{globalSystem = globalWCS; globalSky = NATIVEWCS;;
    break;}
case 17:
#line 272 "ds9parser.Y"
{DISCARD_(0);
    break;}
case 20:
#line 276 "ds9parser.Y"
{DISCARD_(1);
    break;}
case 23:
#line 280 "ds9parser.Y"
{DISCARD_(1);
    break;}
case 24:
#line 281 "ds9parser.Y"
{strncpy(localComment,yyvsp[-1].str,80);;
    break;}
case 26:
#line 283 "ds9parser.Y"
{DISCARD_(1);
    break;}
case 27:
#line 284 "ds9parser.Y"
{strncpy(localComment,yyvsp[-1].str,80);;
    break;}
case 30:
#line 291 "ds9parser.Y"
{yyval.real=yyvsp[0].real;;
    break;}
case 31:
#line 292 "ds9parser.Y"
{yyval.real=yyvsp[0].integer;;
    break;}
case 32:
#line 295 "ds9parser.Y"
{yydebug=1;;
    break;}
case 33:
#line 296 "ds9parser.Y"
{yydebug=0;;
    break;}
case 34:
#line 299 "ds9parser.Y"
{yyval.integer=(yyvsp[0].integer ? 1 : 0);;
    break;}
case 35:
#line 301 "ds9parser.Y"
{yyval.integer=1;;
    break;}
case 36:
#line 302 "ds9parser.Y"
{yyval.integer=1;;
    break;}
case 37:
#line 303 "ds9parser.Y"
{yyval.integer=1;;
    break;}
case 38:
#line 304 "ds9parser.Y"
{yyval.integer=1;;
    break;}
case 39:
#line 306 "ds9parser.Y"
{yyval.integer=0;;
    break;}
case 40:
#line 307 "ds9parser.Y"
{yyval.integer=0;;
    break;}
case 41:
#line 308 "ds9parser.Y"
{yyval.integer=0;;
    break;}
case 42:
#line 309 "ds9parser.Y"
{yyval.integer=0;;
    break;}
case 49:
#line 324 "ds9parser.Y"
{yyval.real = FR->mapAngleToRef(0,localSystem);;
    break;}
case 50:
#line 325 "ds9parser.Y"
{yyval.real = yyvsp[0].real;;
    break;}
case 51:
#line 328 "ds9parser.Y"
{yyval.real = FR->mapAngleToRef(degToRad(yyvsp[0].real),localSystem);;
    break;}
case 52:
#line 329 "ds9parser.Y"
{yyval.real = FR->mapAngleToRef(degToRad(yyvsp[0].real),localSystem);;
    break;}
case 53:
#line 330 "ds9parser.Y"
{yyval.real = FR->mapAngleToRef(yyvsp[0].real,localSystem);;
    break;}
case 54:
#line 333 "ds9parser.Y"
{yyval.real = FITSPTR->mapLenToRef(yyvsp[0].real, localSystem, DEGREES);;
    break;}
case 55:
#line 334 "ds9parser.Y"
{yyval.real = FITSPTR->mapLenToRef(yyvsp[0].real, PHYSICAL);;
    break;}
case 56:
#line 335 "ds9parser.Y"
{yyval.real = FITSPTR->mapLenToRef(yyvsp[0].real, IMAGE);;
    break;}
case 57:
#line 336 "ds9parser.Y"
{yyval.real = FITSPTR->mapLenToRef(yyvsp[0].real, checkWCSSystem(), DEGREES);;
    break;}
case 58:
#line 337 "ds9parser.Y"
{yyval.real = FITSPTR->mapLenToRef(yyvsp[0].real, checkWCSSystem(), ARCMIN);;
    break;}
case 59:
#line 338 "ds9parser.Y"
{yyval.real = FITSPTR->mapLenToRef(yyvsp[0].real, checkWCSSystem(), ARCSEC);;
    break;}
case 60:
#line 342 "ds9parser.Y"
{
	  Vector r = FITSPTR->mapLenToRef(Vector(yyvsp[-2].real,yyvsp[0].real), localSystem, DEGREES);
	  yyval.vector[0] = r[0];
	  yyval.vector[1] = r[1];
	  yyval.vector[2] = r[2];
	;
    break;}
case 61:
#line 349 "ds9parser.Y"
{
	  Vector r = FITSPTR->mapLenToRef(Vector(yyvsp[-2].real,yyvsp[0].real), PHYSICAL);
	  yyval.vector[0] = r[0];
	  yyval.vector[1] = r[1];
	  yyval.vector[2] = r[2];
	;
    break;}
case 62:
#line 356 "ds9parser.Y"
{
	  Vector r = FITSPTR->mapLenToRef(Vector(yyvsp[-2].real,yyvsp[0].real), IMAGE);
	  yyval.vector[0] = r[0];
	  yyval.vector[1] = r[1];
	  yyval.vector[2] = r[2];
	;
    break;}
case 63:
#line 363 "ds9parser.Y"
{
	  Vector r=FITSPTR->mapLenToRef(Vector(yyvsp[-2].real,yyvsp[0].real),checkWCSSystem(),DEGREES);
	  yyval.vector[0] = r[0];
	  yyval.vector[1] = r[1];
	  yyval.vector[2] = r[2];
	;
    break;}
case 64:
#line 370 "ds9parser.Y"
{
	  Vector r=FITSPTR->mapLenToRef(Vector(yyvsp[-2].real,yyvsp[0].real),checkWCSSystem(),ARCMIN);
	  yyval.vector[0] = r[0];
	  yyval.vector[1] = r[1];
	  yyval.vector[2] = r[2];
	;
    break;}
case 65:
#line 377 "ds9parser.Y"
{
	  Vector r=FITSPTR->mapLenToRef(Vector(yyvsp[-2].real,yyvsp[0].real),checkWCSSystem(),ARCSEC);
	  yyval.vector[0] = r[0];
	  yyval.vector[1] = r[1];
	  yyval.vector[2] = r[2];
	;
    break;}
case 66:
#line 385 "ds9parser.Y"
{yyval.integer = yyvsp[0].integer;;
    break;}
case 67:
#line 388 "ds9parser.Y"
{yyval.real = parseDMS(yyvsp[0].str);;
    break;}
case 68:
#line 392 "ds9parser.Y"
{
	  Vector r;
	  CoordSystem sys = checkWCSSystem();
	  SkyFrame sky = checkWCSSky();
	  if (sky == GALACTIC || sky == ECLIPTIC) 
	    r = FITSPTR->mapToRef(Vector(yyvsp[-2].real,yyvsp[0].real), sys, sky);
	  else
	    r = FITSPTR->mapToRef(Vector(yyvsp[-2].real*360./24.,yyvsp[0].real), sys, sky);

	  yyval.vector[0] = r[0];
	  yyval.vector[1] = r[1];
	  yyval.vector[2] = r[2];
	;
    break;}
case 69:
#line 405 "ds9parser.Y"
{mksign2 = mksign;;
    break;}
case 70:
#line 406 "ds9parser.Y"
{
	  Vector r = FITSPTR->mapToRef(
	    Vector(hmsToDegree(mksign2,yyvsp[-7].integer,yyvsp[-6].integer,yyvsp[-5].real),dmsToDegree(mksign,yyvsp[-2].integer,yyvsp[-1].real,yyvsp[0].real)),
	    checkWCSSystem(), checkWCSSky());
	  yyval.vector[0] = r[0];
	  yyval.vector[1] = r[1];
	  yyval.vector[2] = r[2];
	;
    break;}
case 71:
#line 414 "ds9parser.Y"
{mksign2 = mksign;;
    break;}
case 72:
#line 416 "ds9parser.Y"
{
	  Vector r = FITSPTR->mapToRef(
	    Vector(dmsToDegree(mksign2,yyvsp[-7].integer,yyvsp[-6].real,yyvsp[-5].real),dmsToDegree(mksign,yyvsp[-2].integer,yyvsp[-1].real,yyvsp[0].real)),
	    checkWCSSystem(), checkWCSSky());
	  yyval.vector[0] = r[0];
	  yyval.vector[1] = r[1];
	  yyval.vector[2] = r[2];
	;
    break;}
case 73:
#line 425 "ds9parser.Y"
{
	  Vector r = FITSPTR->mapToRef(Vector(yyvsp[-2].real,yyvsp[0].real), localSystem, localSky);
	  yyval.vector[0] = r[0];
	  yyval.vector[1] = r[1];
	  yyval.vector[2] = r[2];
	;
    break;}
case 74:
#line 432 "ds9parser.Y"
{
	  Vector r = FITSPTR->mapToRef(Vector(yyvsp[-2].real,yyvsp[0].real), 
	    checkWCSSystem(), checkWCSSky());
	  yyval.vector[0] = r[0];
	  yyval.vector[1] = r[1];
	  yyval.vector[2] = r[2];
	;
    break;}
case 75:
#line 440 "ds9parser.Y"
{
	  Vector r = FITSPTR->mapToRef(Vector(yyvsp[-2].real,yyvsp[0].real), IMAGE);
	  yyval.vector[0] = r[0];
	  yyval.vector[1] = r[1];
	  yyval.vector[2] = r[2];
	;
    break;}
case 76:
#line 447 "ds9parser.Y"
{
	  Vector r = FITSPTR->mapToRef(Vector(yyvsp[-2].real,yyvsp[0].real), PHYSICAL);
	  yyval.vector[0] = r[0];
	  yyval.vector[1] = r[1];
	;
    break;}
case 77:
#line 453 "ds9parser.Y"
{
	  Vector rx = FITSPTR->mapToRef(Vector(yyvsp[-2].real,yyvsp[-2].real), IMAGE);
	  Vector ry = FITSPTR->mapToRef(Vector(yyvsp[0].real,yyvsp[0].real), PHYSICAL);
	  yyval.vector[0] = rx[0];
	  yyval.vector[1] = ry[0];
	  yyval.vector[2] = 1;
	;
    break;}
case 78:
#line 461 "ds9parser.Y"
{
	  Vector rx = FITSPTR->mapToRef(Vector(yyvsp[-2].real,yyvsp[-2].real), PHYSICAL);
	  Vector ry = FITSPTR->mapToRef(Vector(yyvsp[0].real,yyvsp[0].real), IMAGE);
	  yyval.vector[0] = rx[0];
	  yyval.vector[1] = ry[0];
	  yyval.vector[2] = 1;
	;
    break;}
case 79:
#line 470 "ds9parser.Y"
{yyval.integer = IMAGE;;
    break;}
case 80:
#line 471 "ds9parser.Y"
{yyval.integer = PHYSICAL;;
    break;}
case 81:
#line 472 "ds9parser.Y"
{yyval.integer = DETECTOR;;
    break;}
case 82:
#line 473 "ds9parser.Y"
{yyval.integer = AMPLIFIER;;
    break;}
case 83:
#line 474 "ds9parser.Y"
{yyval.integer = yyvsp[0].integer;;
    break;}
case 84:
#line 477 "ds9parser.Y"
{yyval.integer = WCS;;
    break;}
case 85:
#line 478 "ds9parser.Y"
{yyval.integer = WCSA;;
    break;}
case 86:
#line 479 "ds9parser.Y"
{yyval.integer = WCSB;;
    break;}
case 87:
#line 480 "ds9parser.Y"
{yyval.integer = WCSC;;
    break;}
case 88:
#line 481 "ds9parser.Y"
{yyval.integer = WCSD;;
    break;}
case 89:
#line 482 "ds9parser.Y"
{yyval.integer = WCSE;;
    break;}
case 90:
#line 483 "ds9parser.Y"
{yyval.integer = WCSF;;
    break;}
case 91:
#line 484 "ds9parser.Y"
{yyval.integer = WCSG;;
    break;}
case 92:
#line 485 "ds9parser.Y"
{yyval.integer = WCSH;;
    break;}
case 93:
#line 486 "ds9parser.Y"
{yyval.integer = WCSI;;
    break;}
case 94:
#line 487 "ds9parser.Y"
{yyval.integer = WCSJ;;
    break;}
case 95:
#line 488 "ds9parser.Y"
{yyval.integer = WCSK;;
    break;}
case 96:
#line 489 "ds9parser.Y"
{yyval.integer = WCSL;;
    break;}
case 97:
#line 490 "ds9parser.Y"
{yyval.integer = WCSM;;
    break;}
case 98:
#line 491 "ds9parser.Y"
{yyval.integer = WCSN;;
    break;}
case 99:
#line 492 "ds9parser.Y"
{yyval.integer = WCSO;;
    break;}
case 100:
#line 493 "ds9parser.Y"
{yyval.integer = WCSP;;
    break;}
case 101:
#line 494 "ds9parser.Y"
{yyval.integer = WCSQ;;
    break;}
case 102:
#line 495 "ds9parser.Y"
{yyval.integer = WCSR;;
    break;}
case 103:
#line 496 "ds9parser.Y"
{yyval.integer = WCSS;;
    break;}
case 104:
#line 497 "ds9parser.Y"
{yyval.integer = WCST;;
    break;}
case 105:
#line 498 "ds9parser.Y"
{yyval.integer = WCSU;;
    break;}
case 106:
#line 499 "ds9parser.Y"
{yyval.integer = WCSV;;
    break;}
case 107:
#line 500 "ds9parser.Y"
{yyval.integer = WCSW;;
    break;}
case 108:
#line 501 "ds9parser.Y"
{yyval.integer = WCSX;;
    break;}
case 109:
#line 502 "ds9parser.Y"
{yyval.integer = WCSY;;
    break;}
case 110:
#line 503 "ds9parser.Y"
{yyval.integer = WCSZ;;
    break;}
case 111:
#line 506 "ds9parser.Y"
{yyval.integer = FK4;;
    break;}
case 112:
#line 507 "ds9parser.Y"
{yyval.integer = FK4;;
    break;}
case 113:
#line 508 "ds9parser.Y"
{yyval.integer = FK5;;
    break;}
case 114:
#line 509 "ds9parser.Y"
{yyval.integer = FK5;;
    break;}
case 115:
#line 510 "ds9parser.Y"
{yyval.integer = ICRS;;
    break;}
case 116:
#line 511 "ds9parser.Y"
{yyval.integer = GALACTIC;;
    break;}
case 117:
#line 512 "ds9parser.Y"
{yyval.integer = ECLIPTIC;;
    break;}
case 118:
#line 515 "ds9parser.Y"
{yyval.integer=DEGREES;;
    break;}
case 119:
#line 516 "ds9parser.Y"
{yyval.integer=ARCMIN;;
    break;}
case 120:
#line 517 "ds9parser.Y"
{yyval.integer=ARCSEC;;
    break;}
case 121:
#line 520 "ds9parser.Y"
{yyval.integer = Marker::SELECT;;
    break;}
case 122:
#line 521 "ds9parser.Y"
{yyval.integer = Marker::EDIT;;
    break;}
case 123:
#line 522 "ds9parser.Y"
{yyval.integer = Marker::MOVE;;
    break;}
case 124:
#line 523 "ds9parser.Y"
{yyval.integer = Marker::ROTATE;;
    break;}
case 125:
#line 524 "ds9parser.Y"
{yyval.integer = Marker::DELETE;;
    break;}
case 126:
#line 525 "ds9parser.Y"
{yyval.integer = Marker::HIGHLITE;;
    break;}
case 127:
#line 526 "ds9parser.Y"
{yyval.integer = Marker::INCLUDE;;
    break;}
case 128:
#line 527 "ds9parser.Y"
{yyval.integer = Marker::SOURCE;;
    break;}
case 129:
#line 528 "ds9parser.Y"
{yyval.integer = Marker::FIXED;;
    break;}
case 132:
#line 536 "ds9parser.Y"
{
	  setProps(&globalProps,yyvsp[-2].integer,yyvsp[0].integer);
	  setProps(&localProps,yyvsp[-2].integer,yyvsp[0].integer);
	;
    break;}
case 133:
#line 541 "ds9parser.Y"
{
	  strncpy(globalColor,yyvsp[0].str,16);
	  strncpy(localColor,yyvsp[0].str,16);
	;
    break;}
case 134:
#line 545 "ds9parser.Y"
{globalWidth = localWidth = yyvsp[0].integer;;
    break;}
case 135:
#line 547 "ds9parser.Y"
{
	  strncpy(globalFont,yyvsp[0].str,32);
	  strncpy(localFont,yyvsp[0].str,32);
	;
    break;}
case 136:
#line 552 "ds9parser.Y"
{
	  strncpy(globalText,yyvsp[0].str,80);
	  strncpy(localText,yyvsp[0].str,80);
	;
    break;}
case 137:
#line 557 "ds9parser.Y"
{
	  setProps(&globalProps,Marker::SOURCE,1);
	  setProps(&localProps,Marker::SOURCE,1);
	;
    break;}
case 138:
#line 562 "ds9parser.Y"
{
	  setProps(&globalProps,Marker::SOURCE,0);
	  setProps(&localProps,Marker::SOURCE,0);
	;
    break;}
case 139:
#line 567 "ds9parser.Y"
{
	  globalPoint = localPoint = yyvsp[0].integer;
	;
    break;}
case 140:
#line 571 "ds9parser.Y"
{
	  globalLine1 = localLine1 = yyvsp[-1].integer;
	  globalLine2 = localLine2 = yyvsp[0].integer;
	;
    break;}
case 141:
#line 576 "ds9parser.Y"
{
	;
    break;}
case 142:
#line 579 "ds9parser.Y"
{
	  strncpy(globalCompassNorth,yyvsp[-3].str,80);
	  strncpy(globalCompassEast,yyvsp[-2].str,80);
	  strncpy(localCompassNorth,yyvsp[-3].str,80);
	  strncpy(localCompassEast,yyvsp[-2].str,80);
	  globalCompassNArrow = localCompassNArrow = yyvsp[-1].integer;
	  globalCompassEArrow = localCompassEArrow = yyvsp[0].integer;
	;
    break;}
case 143:
#line 588 "ds9parser.Y"
{
	  globalTextAngle = localTextAngle = yyvsp[0].real;
	;
    break;}
case 144:
#line 591 "ds9parser.Y"
{globalWCS = (CoordSystem)yyvsp[0].integer;;
    break;}
case 145:
#line 595 "ds9parser.Y"
{
	  globalRulerCoordSystem = localRulerCoordSystem = (CoordSystem)yyvsp[-3].integer;
	  globalRulerSkyFrame = localRulerSkyFrame = (SkyFrame)yyvsp[-2].integer;
	  globalRulerDistSystem = localRulerDistSystem = (CoordSystem)yyvsp[-1].integer;
	  globalRulerDistFormat = localRulerDistFormat = (SkyFormat)yyvsp[0].integer;
	;
    break;}
case 146:
#line 602 "ds9parser.Y"
{
	  globalRulerCoordSystem = localRulerCoordSystem = (CoordSystem)yyvsp[-1].integer;
	  globalRulerSkyFrame = localRulerSkyFrame = FK5;
	  globalRulerDistSystem = localRulerDistSystem = (CoordSystem)yyvsp[0].integer;
	  globalRulerDistFormat = localRulerDistFormat = DEGREES;
	;
    break;}
case 147:
#line 609 "ds9parser.Y"
{
	  globalRulerCoordSystem = localRulerCoordSystem = (CoordSystem)yyvsp[-1].integer;
	  globalRulerSkyFrame = localRulerSkyFrame = FK5;
	  globalRulerDistSystem = localRulerDistSystem = WCS;
	  globalRulerDistFormat = localRulerDistFormat = (SkyFormat)yyvsp[0].integer;
	;
    break;}
case 148:
#line 616 "ds9parser.Y"
{
	  globalRulerCoordSystem = localRulerCoordSystem = WCS;
	  globalRulerSkyFrame = localRulerSkyFrame = (SkyFrame)yyvsp[-1].integer;
	  globalRulerDistSystem = localRulerDistSystem = (CoordSystem)yyvsp[0].integer;
	  globalRulerDistFormat = localRulerDistFormat = DEGREES;
	;
    break;}
case 149:
#line 623 "ds9parser.Y"
{
	  globalRulerCoordSystem = localRulerCoordSystem = WCS;
	  globalRulerSkyFrame = localRulerSkyFrame = (SkyFrame)yyvsp[-1].integer;
	  globalRulerDistSystem = localRulerDistSystem = WCS;
	  globalRulerDistFormat = localRulerDistFormat = (SkyFormat)yyvsp[0].integer;
	;
    break;}
case 150:
#line 630 "ds9parser.Y"
{
	  globalRulerCoordSystem = localRulerCoordSystem = WCS;
	  globalRulerSkyFrame = localRulerSkyFrame = FK5;
	  globalRulerDistSystem = localRulerDistSystem = (CoordSystem)yyvsp[0].integer;
	  globalRulerDistFormat = localRulerDistFormat = DEGREES;
	;
    break;}
case 151:
#line 637 "ds9parser.Y"
{
	  globalRulerCoordSystem = localRulerCoordSystem = WCS;
	  globalRulerSkyFrame = localRulerSkyFrame = FK5;
	  globalRulerDistSystem = localRulerDistSystem = WCS;
	  globalRulerDistFormat = localRulerDistFormat = (SkyFormat)yyvsp[0].integer;
	;
    break;}
case 152:
#line 644 "ds9parser.Y"
{
	  globalRulerCoordSystem = localRulerCoordSystem = IMAGE;
	  globalRulerSkyFrame = localRulerSkyFrame = FK5;
	  globalRulerDistSystem = localRulerDistSystem = WCS;
	  globalRulerDistFormat = localRulerDistFormat = (SkyFormat)yyvsp[0].integer;
	;
    break;}
case 153:
#line 651 "ds9parser.Y"
{
	  globalRulerCoordSystem = localRulerCoordSystem = IMAGE;
	  globalRulerSkyFrame = localRulerSkyFrame = FK5;
	  globalRulerDistSystem = localRulerDistSystem = IMAGE;
	  globalRulerDistFormat = localRulerDistFormat = DEGREES;
	;
    break;}
case 154:
#line 660 "ds9parser.Y"
{
	  globalCompassCoordSystem = localCompassCoordSystem = (CoordSystem)yyvsp[-1].integer;
	  globalCompassSkyFrame = localCompassSkyFrame = (SkyFrame)yyvsp[0].integer;
	;
    break;}
case 155:
#line 665 "ds9parser.Y"
{
	  globalCompassCoordSystem = localCompassCoordSystem = (CoordSystem)yyvsp[0].integer;
	  globalCompassSkyFrame = localCompassSkyFrame = FK5;
	;
    break;}
case 156:
#line 670 "ds9parser.Y"
{
	  globalCompassCoordSystem = localCompassCoordSystem = WCS;
	  globalCompassSkyFrame = localCompassSkyFrame = (SkyFrame)yyvsp[0].integer;
	;
    break;}
case 157:
#line 675 "ds9parser.Y"
{
	  globalCompassCoordSystem = localCompassCoordSystem = WCS;
	  globalCompassSkyFrame = localCompassSkyFrame = FK5;
	;
    break;}
case 158:
#line 681 "ds9parser.Y"
{
	  // global properties
	  globalSystem = PHYSICAL;
	  globalWCS = WCS;
	  globalSky = NATIVEWCS;
	  globalTile = 1;
	  globalProps =
	    Marker::SELECT | Marker::EDIT | Marker::MOVE |
	    Marker::ROTATE | Marker::DELETE | Marker::HIGHLITE |
	    Marker::INCLUDE | Marker::SOURCE;
	  strcpy(globalColor,"green");
          globalWidth = 1;
	  strcpy(globalFont,"helvetica 10 normal");
	  strcpy(globalText,"");

	  // unique properties
	  globalLine1 = 0;
	  globalLine2 = 0;
	  globalRulerCoordSystem = PHYSICAL;
	  globalRulerSkyFrame = FK5;
	  globalRulerDistSystem = PHYSICAL;
	  globalRulerDistFormat = DEGREES;
	  globalCompassCoordSystem = PHYSICAL;
	  globalCompassSkyFrame = FK5;
	  strcpy(globalCompassNorth,"N");
	  strcpy(globalCompassEast,"E");
	  globalCompassNArrow = 1;
	  globalCompassEArrow = 1;
	  globalPoint = BOXCIRCLE;
	  globalTextAngle=0;

	  aStatus = 0;
	;
    break;}
case 161:
#line 720 "ds9parser.Y"
{setProps(&localProps,yyvsp[-2].integer,yyvsp[0].integer);;
    break;}
case 162:
#line 721 "ds9parser.Y"
{strncpy(localColor,yyvsp[0].str,16);;
    break;}
case 163:
#line 722 "ds9parser.Y"
{localWidth = yyvsp[0].integer;;
    break;}
case 164:
#line 723 "ds9parser.Y"
{strncpy(localFont,yyvsp[0].str,32);;
    break;}
case 165:
#line 724 "ds9parser.Y"
{strncpy(localText,yyvsp[0].str,80);;
    break;}
case 166:
#line 725 "ds9parser.Y"
{taglist.append(new Tag(yyvsp[0].str));;
    break;}
case 167:
#line 726 "ds9parser.Y"
{setProps(&localProps,Marker::SOURCE,1);;
    break;}
case 168:
#line 727 "ds9parser.Y"
{setProps(&localProps,Marker::SOURCE,0);;
    break;}
case 169:
#line 729 "ds9parser.Y"
{localPoint = yyvsp[0].integer;;
    break;}
case 170:
#line 730 "ds9parser.Y"
{localLine1=yyvsp[-1].integer; localLine2=yyvsp[0].integer;;
    break;}
case 172:
#line 733 "ds9parser.Y"
{
	  strncpy(localCompassNorth,yyvsp[-3].str,80);
	  strncpy(localCompassEast,yyvsp[-2].str,80);
	  localCompassNArrow = yyvsp[-1].integer;
	  localCompassEArrow = yyvsp[0].integer;
	;
    break;}
case 173:
#line 739 "ds9parser.Y"
{localTextAngle=yyvsp[0].real;;
    break;}
case 175:
#line 744 "ds9parser.Y"
{
	  localRulerCoordSystem = (CoordSystem)yyvsp[-3].integer;
	  localRulerSkyFrame = (SkyFrame)yyvsp[-2].integer;
	  localRulerDistSystem = (CoordSystem)yyvsp[-1].integer;
	  localRulerDistFormat = (SkyFormat)yyvsp[0].integer;
	;
    break;}
case 176:
#line 751 "ds9parser.Y"
{
	  localRulerCoordSystem = (CoordSystem)yyvsp[-1].integer;
	  localRulerSkyFrame = FK5;
	  localRulerDistSystem = (CoordSystem)yyvsp[0].integer;
	  localRulerDistFormat = DEGREES;
	;
    break;}
case 177:
#line 758 "ds9parser.Y"
{
	  localRulerCoordSystem = (CoordSystem)yyvsp[-1].integer;
	  localRulerSkyFrame = FK5;
	  localRulerDistSystem = WCS;
	  localRulerDistFormat = (SkyFormat)yyvsp[0].integer;
	;
    break;}
case 178:
#line 765 "ds9parser.Y"
{
	  localRulerCoordSystem = WCS;
	  localRulerSkyFrame = (SkyFrame)yyvsp[-1].integer;
	  localRulerDistSystem = (CoordSystem)yyvsp[0].integer;
	  localRulerDistFormat = DEGREES;
	;
    break;}
case 179:
#line 772 "ds9parser.Y"
{
	  localRulerCoordSystem = WCS;
	  localRulerSkyFrame = (SkyFrame)yyvsp[-1].integer;
	  localRulerDistSystem = WCS;
	  localRulerDistFormat = (SkyFormat)yyvsp[0].integer;
	;
    break;}
case 180:
#line 779 "ds9parser.Y"
{
	  localRulerCoordSystem = WCS;
	  localRulerSkyFrame = FK5;
	  localRulerDistSystem = (CoordSystem)yyvsp[0].integer;
	  localRulerDistFormat = DEGREES;
	;
    break;}
case 181:
#line 786 "ds9parser.Y"
{
	  localRulerCoordSystem = WCS;
	  localRulerSkyFrame = FK5;
	  localRulerDistSystem = WCS;
	  localRulerDistFormat = (SkyFormat)yyvsp[0].integer;
	;
    break;}
case 182:
#line 793 "ds9parser.Y"
{
	  localRulerCoordSystem = IMAGE;
	  localRulerSkyFrame = FK5;
	  localRulerDistSystem = WCS;
	  localRulerDistFormat = (SkyFormat)yyvsp[0].integer;
	;
    break;}
case 183:
#line 800 "ds9parser.Y"
{
	  localRulerCoordSystem = IMAGE;
	  localRulerSkyFrame = FK5;
	  localRulerDistSystem = IMAGE;
	  localRulerDistFormat = DEGREES;
	;
    break;}
case 184:
#line 809 "ds9parser.Y"
{
	  localCompassCoordSystem = (CoordSystem)yyvsp[-1].integer;
	  localCompassSkyFrame = (SkyFrame)yyvsp[0].integer;
	;
    break;}
case 185:
#line 814 "ds9parser.Y"
{
	  localCompassCoordSystem = (CoordSystem)yyvsp[0].integer;
	  localCompassSkyFrame = FK5;
	;
    break;}
case 186:
#line 819 "ds9parser.Y"
{
	  localCompassCoordSystem = WCS;
	  localCompassSkyFrame = (SkyFrame)yyvsp[0].integer;
	;
    break;}
case 187:
#line 824 "ds9parser.Y"
{
	  localCompassCoordSystem = WCS;
	  localCompassSkyFrame = FK5;
	;
    break;}
case 188:
#line 830 "ds9parser.Y"
{aNum=0; aAngNum=0;;
    break;}
case 189:
#line 830 "ds9parser.Y"
{localPanda = 2;;
    break;}
case 190:
#line 831 "ds9parser.Y"
{localPanda=0;;
    break;}
case 191:
#line 834 "ds9parser.Y"
{
	  // needed for annulus, ellipse annulus, and box annulus
	  aNum = 2;

	  // global properties
	  localSystem = globalSystem;
	  localSky = globalSky;
	  localProps = globalProps;
	  strcpy(localColor,globalColor);
	  localWidth = globalWidth;
	  strcpy(localFont,globalFont);
	  strcpy(localText,globalText);
	  strcpy(localComment,"");
	  taglist.deleteAll();

	  // unique properties
	  localLine1 = globalLine1;
	  localLine2 = globalLine2;
	  localPoint = globalPoint;
	  localRulerCoordSystem = globalRulerCoordSystem;
	  localRulerSkyFrame = globalRulerSkyFrame;
	  localRulerDistSystem = globalRulerDistSystem;
	  localRulerDistFormat = globalRulerDistFormat;
	  localCompassCoordSystem = globalCompassCoordSystem;
	  localCompassSkyFrame = globalCompassSkyFrame;
	  strcpy(localCompassNorth,globalCompassNorth);
	  strcpy(localCompassEast,globalCompassEast);
	  localCompassNArrow = globalCompassNArrow;
	  localCompassEArrow = globalCompassEArrow;
	  localTextAngle = globalTextAngle;
	  localPanda = 1;
	;
    break;}
case 192:
#line 868 "ds9parser.Y"
{yyval.integer = CIRCLE;;
    break;}
case 193:
#line 869 "ds9parser.Y"
{yyval.integer = BOX;;
    break;}
case 194:
#line 870 "ds9parser.Y"
{yyval.integer = DIAMOND;;
    break;}
case 195:
#line 871 "ds9parser.Y"
{yyval.integer = CROSS;;
    break;}
case 196:
#line 872 "ds9parser.Y"
{yyval.integer = XPT;;
    break;}
case 197:
#line 873 "ds9parser.Y"
{yyval.integer = ARROW;;
    break;}
case 198:
#line 874 "ds9parser.Y"
{yyval.integer = BOXCIRCLE;;
    break;}
case 199:
#line 877 "ds9parser.Y"
{setProps(&localProps, Marker::INCLUDE, 1);;
    break;}
case 200:
#line 878 "ds9parser.Y"
{setProps(&localProps, Marker::INCLUDE, 1);;
    break;}
case 201:
#line 879 "ds9parser.Y"
{setProps(&localProps, Marker::INCLUDE, 0);;
    break;}
case 202:
#line 883 "ds9parser.Y"
{FR->createCircleCmd(Vector(yyvsp[-4].vector),yyvsp[-2].real,
	    localColor,localWidth,localFont,
	    localText,localProps,localComment,taglist);;
    break;}
case 203:
#line 888 "ds9parser.Y"
{
	  // for ellipse annulus
	  aStatus = 1;
	  aCenter = Vector(yyvsp[-6].vector);
	  aAngle[0] = yyvsp[-2].real;
	  aVector[0] = Vector(yyvsp[-4].vector);
	  aNumsao = 1;
	  strncpy(aColor,localColor,16);
	  aWidth = localWidth;
	  strncpy(aFont,localFont,32);
	  strncpy(aText,localText,80);
	  strncpy(aComment,localComment,80);
	  aProps = localProps;

	  FR->createEllipseCmd(Vector(yyvsp[-6].vector),Vector(yyvsp[-4].vector),yyvsp[-2].real,
	  localColor,localWidth,localFont,localText,localProps,localComment,
	  taglist);
	;
    break;}
case 204:
#line 908 "ds9parser.Y"
{
	  // for box annulus
	  aStatus = 3;
	  aCenter = Vector(yyvsp[-6].vector);
	  aAngle[0] = yyvsp[-2].real;
	  aVector[0] = Vector(yyvsp[-4].vector);
	  aNumsao = 1;
	  strncpy(aColor,localColor,16);
	  aWidth = localWidth;
	  strncpy(aFont,localFont,32);
	  strncpy(aText,localText,80);
	  strncpy(aComment,localComment,80);
	  aProps = localProps;

	  FR->createBoxCmd(Vector(yyvsp[-6].vector),Vector(yyvsp[-4].vector),yyvsp[-2].real,
	    localColor,localWidth,localFont,localText,localProps,localComment,
	    taglist);
	;
    break;}
case 205:
#line 927 "ds9parser.Y"
{FR->createBoxCmd(Vector(yyvsp[-6].vector),Vector(yyvsp[-4].vector),yyvsp[-2].real,
	    localColor,localWidth,localFont,
	    localText,localProps,localComment,taglist);;
    break;}
case 206:
#line 931 "ds9parser.Y"
{polylist.deleteAll();;
    break;}
case 207:
#line 932 "ds9parser.Y"
{FR->createPolygonCmd(polylist, localColor,localWidth,localFont,
	      localText,localProps,localComment,taglist);;
    break;}
case 208:
#line 936 "ds9parser.Y"
{FR->createLineCmd(Vector(yyvsp[-4].vector),Vector(yyvsp[-2].vector),localLine1,localLine2,
	    localColor,localWidth,localFont,
	    localText,localProps,localComment,taglist);;
    break;}
case 209:
#line 941 "ds9parser.Y"
{FR->createTextCmd(Vector(yyvsp[-2].vector),localTextAngle,
	    localColor,localWidth,localFont,
	    localText,localProps,localComment,taglist);;
    break;}
case 210:
#line 944 "ds9parser.Y"
{strncpy(localText,yyvsp[-1].str,80);;
    break;}
case 211:
#line 945 "ds9parser.Y"
{FR->createTextCmd(Vector(yyvsp[-5].vector),localTextAngle,
	    localColor,localWidth,localFont,
	    localText,localProps,localComment,taglist);;
    break;}
case 212:
#line 950 "ds9parser.Y"
{FR->createRulerCmd(Vector(yyvsp[-4].vector),Vector(yyvsp[-2].vector),
   	   localRulerCoordSystem, localRulerSkyFrame,
	   localRulerDistSystem, localRulerDistFormat,
	   localColor,localWidth,localFont,
	   localText,localProps,localComment,taglist);;
    break;}
case 213:
#line 956 "ds9parser.Y"
{FR->createCompassCmd(Vector(yyvsp[-4].vector), yyvsp[-2].real,
	   localCompassNorth, localCompassEast, 
	   localCompassNArrow, localCompassEArrow,
   	   localCompassCoordSystem, localCompassSkyFrame,
	   localColor,localWidth,localFont,
	   localText,localProps,localComment,taglist);;
    break;}
case 214:
#line 963 "ds9parser.Y"
{
	  FR->createProjectionCmd(Vector(yyvsp[-6].vector),Vector(yyvsp[-4].vector),yyvsp[-2].real,
	  "ProjectionPlot", "DeleteProjectionPlot",
	  localColor,localWidth,localFont,
	  localText,localProps,localComment,taglist);
	;
    break;}
case 215:
#line 971 "ds9parser.Y"
{
	  switch (localPoint) {
	  case CIRCLE:
	    FR->createCirclePointCmd(Vector(yyvsp[-2].vector),
	      localColor,localWidth,localFont,
	      localText,localProps,localComment,taglist);
	    break;
	  case BOX:
	    FR->createBoxPointCmd(Vector(yyvsp[-2].vector),
	      localColor,localWidth,localFont,
	      localText,localProps,localComment,taglist);
	    break;
	  case DIAMOND:
	    FR->createDiamondPointCmd(Vector(yyvsp[-2].vector),
	      localColor,localWidth,localFont,
	      localText,localProps,localComment,taglist);
	    break;
	  case CROSS:
	    FR->createCrossPointCmd(Vector(yyvsp[-2].vector),
	      localColor,localWidth,localFont,
	      localText,localProps,localComment,taglist);
	    break;
	  case XPT:
	    FR->createExPointCmd(Vector(yyvsp[-2].vector),
	      localColor,localWidth,localFont,
	      localText,localProps,localComment,taglist);
	    break;
	  case ARROW:
	    FR->createArrowPointCmd(Vector(yyvsp[-2].vector),
	      localColor,localWidth,localFont,
	      localText,localProps,localComment,taglist);
	    break;
	  case BOXCIRCLE:
	    FR->createBoxCirclePointCmd(Vector(yyvsp[-2].vector),
	      localColor,localWidth,localFont,
	      localText,localProps,localComment,taglist);
	    break;
	  }
	;
    break;}
case 216:
#line 1011 "ds9parser.Y"
{FR->createCirclePointCmd(Vector(yyvsp[-2].vector),
	    localColor,localWidth,localFont,
	    localText,localProps,localComment,taglist);;
    break;}
case 217:
#line 1015 "ds9parser.Y"
{FR->createBoxPointCmd(Vector(yyvsp[-2].vector),
	    localColor,localWidth,localFont,
	    localText,localProps,localComment,taglist);;
    break;}
case 218:
#line 1019 "ds9parser.Y"
{FR->createDiamondPointCmd(Vector(yyvsp[-2].vector),
	    localColor,localWidth,localFont,
	    localText,localProps,localComment,taglist);;
    break;}
case 219:
#line 1023 "ds9parser.Y"
{FR->createCrossPointCmd(Vector(yyvsp[-2].vector),
	    localColor,localWidth,localFont,
	    localText,localProps,localComment,taglist);;
    break;}
case 220:
#line 1027 "ds9parser.Y"
{FR->createExPointCmd(Vector(yyvsp[-2].vector),
	    localColor,localWidth,localFont,
	    localText,localProps,localComment,taglist);;
    break;}
case 221:
#line 1031 "ds9parser.Y"
{FR->createArrowPointCmd(Vector(yyvsp[-2].vector),
	    localColor,localWidth,localFont,
	    localText,localProps,localComment,taglist);;
    break;}
case 222:
#line 1035 "ds9parser.Y"
{FR->createBoxCirclePointCmd(Vector(yyvsp[-2].vector),
	    localColor,localWidth,localFont,
	    localText,localProps,localComment,taglist);;
    break;}
case 223:
#line 1040 "ds9parser.Y"
{FR->createAnnulusCmd(Vector(yyvsp[-6].vector),yyvsp[-4].real,yyvsp[-2].real,1,
	    localColor,localWidth,localFont,
	    localText,localProps,localComment,taglist);;
    break;}
case 224:
#line 1045 "ds9parser.Y"
{
	  aAnnuli[0] = yyvsp[-6].real;
	  aAnnuli[1] = yyvsp[-4].real;
	  FR->createAnnulusCmd(Vector(yyvsp[-8].vector),aAnnuli,aNum,
	  localColor,localWidth,localFont,localText,localProps,localComment,
	  taglist);
	;
    break;}
case 225:
#line 1053 "ds9parser.Y"
{FR->createAnnulusCmd(Vector(yyvsp[-8].vector),yyvsp[-6].real,yyvsp[-4].real,yyvsp[-2].integer,
	    localColor,localWidth,localFont,
	    localText,localProps,localComment,taglist);;
    break;}
case 226:
#line 1058 "ds9parser.Y"
{
	  // prefered syntax
	  FR->createEllipseAnnulusCmd(Vector(yyvsp[-8].vector),
	    Vector(yyvsp[-6].vector),Vector(yyvsp[-4].vector),1,yyvsp[-2].real,
	    localColor,localWidth,localFont,
	    localText,localProps,localComment,taglist);
	;
    break;}
case 227:
#line 1067 "ds9parser.Y"
{
	  // prefered syntax
	  FR->createEllipseAnnulusCmd(Vector(yyvsp[-10].vector),
	    Vector(yyvsp[-8].vector),Vector(yyvsp[-6].vector),yyvsp[-4].integer,yyvsp[-2].real,
	    localColor,localWidth,localFont,
	    localText,localProps,localComment,taglist);
	;
    break;}
case 228:
#line 1076 "ds9parser.Y"
{
	  // prefered syntax
	  aVector[0] = Vector(yyvsp[-8].vector);
	  aVector[1] = Vector(yyvsp[-6].vector);
	  FR->createEllipseAnnulusCmd(Vector(yyvsp[-10].vector),yyvsp[-2].real,aNum,
	    aVector,localColor,localWidth,localFont,
	    localText,localProps,localComment,taglist);
	;
    break;}
case 229:
#line 1087 "ds9parser.Y"
{	
	  // old saoimage syntax
	  aStatus = 2;
	  aVector[aNumsao++] = Vector(yyvsp[-13].vector);
	;
    break;}
case 230:
#line 1094 "ds9parser.Y"
{
	  // prefered syntax
	  FR->createBoxAnnulusCmd(Vector(yyvsp[-8].vector),
	    Vector(yyvsp[-6].vector),Vector(yyvsp[-4].vector),1,yyvsp[-2].real,
	    localColor,localWidth,localFont,
	    localText,localProps,localComment,taglist);
	;
    break;}
case 231:
#line 1103 "ds9parser.Y"
{
	  // prefered syntax
	  aVector[0] = Vector(yyvsp[-8].vector);
	  aVector[1] = Vector(yyvsp[-6].vector);
	  FR->createBoxAnnulusCmd(Vector(yyvsp[-10].vector),yyvsp[-2].real,aNum,
	  aVector,localColor,localWidth,localFont,
	  localText,localProps,localComment,taglist);
	;
    break;}
case 232:
#line 1113 "ds9parser.Y"
{
	  // prefered syntax
	  FR->createBoxAnnulusCmd(Vector(yyvsp[-10].vector),
	    Vector(yyvsp[-8].vector),Vector(yyvsp[-6].vector),yyvsp[-4].integer,yyvsp[-2].real,
	    localColor,localWidth,localFont,
	    localText,localProps,localComment,taglist);
	;
    break;}
case 233:
#line 1123 "ds9parser.Y"
{	
	  // old saoimage syntax
	  aStatus = 4;
	  aVector[aNumsao++] = Vector(yyvsp[-13].vector);
	;
    break;}
case 234:
#line 1131 "ds9parser.Y"
{
	  switch (localPanda) {
	  case 0: /* ignore it */
	    break;
	  case 1: /* normal panda */
	    FR->createPandaCmd(Vector(yyvsp[-14].vector),yyvsp[-12].real,yyvsp[-10].real,yyvsp[-8].integer,yyvsp[-6].real,yyvsp[-4].real,yyvsp[-2].integer,
	      localColor,localWidth,localFont,
	      localText,localProps,localComment,taglist);
	    break;
	  case 2: /* one of our special pandas */
	    FR->createPandaCmd(Vector(yyvsp[-14].vector),aAngle,aAngNum,aAnnuli,aNum,
	      localColor,localWidth,localFont,
	      localText,localProps,localComment,taglist);
	    break;
	  }
	;
    break;}
case 241:
#line 1158 "ds9parser.Y"
{polylist.append(new Vertex(yyvsp[0].vector));;
    break;}
case 244:
#line 1166 "ds9parser.Y"
{
	  if (aNum < MAXANNULI)
	    aAnnuli[aNum++] = yyvsp[0].real;
	;
    break;}
case 247:
#line 1177 "ds9parser.Y"
{
	  if (aAngNum < MAXANGLES)
	    aAngle[aAngNum++] = yyvsp[0].real;
	;
    break;}
case 250:
#line 1187 "ds9parser.Y"
{aVector[aNum++] = Vector(yyvsp[-2].real,yyvsp[0].real);;
    break;}
case 251:
#line 1191 "ds9parser.Y"
{
	  // old style annulus
	  switch (aStatus) {
	  case 0: // do nothing
	    break;
	  case 1: // we found just an ellipse, do nothing
	    break;
	  case 2: // ok we have an ellipse annulus
	    FR->markerDeleteLastCmd(); // delete the previous ellipse
	    FR->createEllipseAnnulusCmd(aCenter,aAngle[0],aNumsao,aVector,
	      aColor,aWidth,aFont,aText,aProps,aComment,taglist);
	    break;
	  case 3: // we found just a box, do nothing
	    break;
	  case 4: // ok, we have a box annulus
	    FR->markerDeleteLastCmd(); // delete the previous box
	    FR->createBoxAnnulusCmd(aCenter,aAngle[0],aNumsao,aVector,
	      aColor,aWidth,aFont,aText,aProps,aComment,taglist);
	    break;
	  }
	  aStatus = 0;
	;
    break;}
}

#line 705 "/usr/share/bison/bison.simple"


  yyvsp -= yylen;
  yyssp -= yylen;
#if YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;
#if YYLSP_NEEDED
  *++yylsp = yyloc;
#endif

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("parse error, unexpected ") + 1;
	  yysize += yystrlen (yytname[YYTRANSLATE (yychar)]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "parse error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[YYTRANSLATE (yychar)]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exhausted");
	}
      else
#endif /* defined (YYERROR_VERBOSE) */
	yyerror ("parse error");
    }
  goto yyerrlab1;


/*--------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action |
`--------------------------------------------------*/
yyerrlab1:
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;
      YYDPRINTF ((stderr, "Discarding token %d (%s).\n",
		  yychar, yytname[yychar1]));
      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;


/*-------------------------------------------------------------------.
| yyerrdefault -- current state does not do anything special for the |
| error token.                                                       |
`-------------------------------------------------------------------*/
yyerrdefault:
#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */

  /* If its default is to accept any token, ok.  Otherwise pop it.  */
  yyn = yydefact[yystate];
  if (yyn)
    goto yydefault;
#endif


/*---------------------------------------------------------------.
| yyerrpop -- pop the current state because it cannot handle the |
| error token                                                    |
`---------------------------------------------------------------*/
yyerrpop:
  if (yyssp == yyss)
    YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#if YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "Error: state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

/*--------------.
| yyerrhandle.  |
`--------------*/
yyerrhandle:
  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

/*---------------------------------------------.
| yyoverflowab -- parser overflow comes here.  |
`---------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}
#line 1214 "ds9parser.Y"


static void setProps(unsigned short* props, unsigned short prop, int value)
{
  if (value)
    *props |= prop;
  else
    *props &= ~prop;
}

static CoordSystem checkWCSSystem()
{
  switch (localSystem) {
  case IMAGE:
  case PHYSICAL:
    return WCS;
  default:
   return localSystem;
  }
}

static SkyFrame checkWCSSky()
{
  switch (localSystem) {
  case IMAGE:
  case PHYSICAL:
    return NATIVEWCS;
  default:
   return localSky;
  }
}

