#ifndef BISON_PROSPARSER_H
# define BISON_PROSPARSER_H

#ifndef YYSTYPE
typedef union {
  double real;
  int integer;
  char str[256];
  double vector[3];
} yystype;
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif
# define	INT	257
# define	REAL	258
# define	STRING	259
# define	HOUR	260
# define	MINUTE	261
# define	SECOND	262
# define	DEGREE	263
# define	ARCMINUTE	264
# define	ARCSECOND	265
# define	RADIAN	266
# define	SEXSTR	267
# define	ANNULUS_	268
# define	B1950_	269
# define	BOX_	270
# define	CIRCLE_	271
# define	DEBUG_	272
# define	ECLIPTIC_	273
# define	ELLIPSE_	274
# define	EQUATORIAL_	275
# define	GALACTIC_	276
# define	J2000_	277
# define	LOGICAL_	278
# define	N_	279
# define	OFF_	280
# define	ON_	281
# define	PHYSICAL_	282
# define	POINT_	283
# define	POLYGON_	284
# define	ROTBOX_	285
# define	VERSION_	286


extern YYSTYPE proslval;

#endif /* not BISON_PROSPARSER_H */
