/* A Bison parser, made from saoparser.Y
   by GNU bison 1.35.  */

#define YYBISON 1  /* Identify Bison output.  */

#define yyparse saoparse
#define yylex saolex
#define yyerror saoerror
#define yylval saolval
#define yychar saochar
#define yydebug saodebug
#define yynerrs saonerrs
# define	INT	257
# define	REAL	258
# define	STRING	259
# define	ANNULUS_	260
# define	BOX_	261
# define	CIRCLE_	262
# define	DEBUG_	263
# define	ELLIPSE_	264
# define	N_	265
# define	OFF_	266
# define	ON_	267
# define	POINT_	268
# define	POLYGON_	269
# define	ROTBOX_	270
# define	VERSION_	271

#line 5 "saoparser.Y"

#define YYPARSE_PARAM fr
#define YYDEBUG 1

#define FR ((FrameBase*)fr)
#define FITSPTR (FR->findFits(1))

#define DISCARD_(x) {yyclearin; saoDiscard(x);}

#include <math.h>
#include <string.h>
#include <iostream.h>

#include "framebase.h"
#include "fitsimage.h"
#include "util.h"
#include "vector.h"
#include "list.h"
#include "basemarker.h"
#include "coord.h"

extern int saolex(void);
extern void saoerror(const char*);
extern void saoDiscard(int);

static unsigned short globalProps;
static unsigned short localProps;

static char *color = "green";
static char *font = "helvetica 10 normal";
static char *text = "";

static char localComment[80];

static List<Vertex> polylist;
static List<Tag> taglist;

static double aAnnuli[MAXANNULI];
static Vector aVector[MAXANNULI];
static int aNum;
static int aStatus;
static Vector aCenter;
static double aAngle;
static unsigned short aProps;
static char aComment[80];

static void setProps(unsigned short* props, unsigned short prop, int value);


#line 55 "saoparser.Y"
#ifndef YYSTYPE
typedef union {
  double real;
  int integer;
  char str[256];
  double vector[3];
} yystype;
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif
#ifndef YYDEBUG
# define YYDEBUG 0
#endif



#define	YYFINAL		138
#define	YYFLAG		-32768
#define	YYNTBASE	29

/* YYTRANSLATE(YYLEX) -- Bison token number corresponding to YYLEX. */
#define YYTRANSLATE(x) ((unsigned)(x) <= 271 ? yytranslate[x] : 59)

/* YYTRANSLATE[YYLEX] -- Bison token number corresponding to YYLEX. */
static const char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      18,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    27,     2,    28,     2,     2,    26,     2,
      21,    22,     2,    24,    20,    25,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,    19,
       2,    23,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17
};

#if YYDEBUG
static const short yyprhs[] =
{
       0,     0,     4,     8,    11,    12,    15,    17,    21,    23,
      25,    27,    29,    31,    33,    35,    36,    38,    39,    41,
      42,    44,    45,    47,    49,    51,    55,    59,    63,    64,
      65,    66,    68,    70,    78,    88,    98,   108,   109,   116,
     122,   132,   133,   146,   158,   177,   196,   200,   202,   204,
     208,   210,   212,   213,   214,   218,   220,   221
};
static const short yyrhs[] =
{
      44,    30,    54,     0,    30,    31,    32,     0,    31,    32,
       0,     0,     9,    34,     0,    17,     0,    45,    46,    47,
       0,    55,     0,    18,     0,    19,     0,     4,     0,     3,
       0,    13,     0,    12,     0,     0,    20,     0,     0,    21,
       0,     0,    22,     0,     0,    39,     0,    33,     0,    33,
       0,    33,    35,    33,     0,    11,    23,     3,     0,    33,
      35,    33,     0,     0,     0,     0,    24,     0,    25,     0,
       8,    36,    43,    35,    40,    37,    57,     0,    10,    36,
      43,    35,    41,    35,    38,    37,    57,     0,     7,    36,
      43,    35,    41,    35,    38,    37,    57,     0,    16,    36,
      43,    35,    41,    35,    38,    37,    57,     0,     0,    15,
      48,    36,    50,    37,    57,     0,    14,    36,    43,    37,
      57,     0,     6,    36,    43,    35,    40,    35,    40,    37,
      57,     0,     0,     6,    36,    43,    35,    40,    35,    40,
      35,    49,    52,    37,    57,     0,     6,    36,    43,    35,
      40,    35,    40,    35,    42,    37,    57,     0,    10,    36,
      43,    35,    41,    35,    38,    37,    26,    27,    10,    36,
      43,    35,    41,    35,    38,    37,     0,     7,    36,    43,
      35,    41,    35,    38,    37,    26,    27,     7,    36,    43,
      35,    41,    35,    38,    37,     0,    50,    35,    51,     0,
      51,     0,    43,     0,    52,    35,    53,     0,    53,     0,
      40,     0,     0,     0,    28,    56,     5,     0,    54,     0,
       0,    28,    58,     5,    54,     0
};

#endif

#if YYDEBUG
/* YYRLINE[YYN] -- source line where rule number YYN was defined. */
static const short yyrline[] =
{
       0,    90,    93,    94,    97,    98,    99,   100,   101,   104,
     105,   108,   109,   112,   113,   116,   117,   120,   121,   124,
     125,   128,   129,   132,   135,   138,   147,   150,   159,   167,
     170,   171,   172,   175,   179,   194,   208,   212,   212,   216,
     220,   223,   223,   231,   235,   242,   250,   251,   254,   257,
     258,   261,   264,   288,   288,   291,   292,   292
};
#endif


#if (YYDEBUG) || defined YYERROR_VERBOSE

/* YYTNAME[TOKEN_NUM] -- String name of the token TOKEN_NUM. */
static const char *const yytname[] =
{
  "$", "error", "$undefined.", "INT", "REAL", "STRING", "ANNULUS_", "BOX_", 
  "CIRCLE_", "DEBUG_", "ELLIPSE_", "N_", "OFF_", "ON_", "POINT_", 
  "POLYGON_", "ROTBOX_", "VERSION_", "'\\n'", "';'", "','", "'('", "')'", 
  "'='", "'+'", "'-'", "'&'", "'!'", "'#'", "start", "commands", 
  "command", "terminator", "numeric", "debug", "sp", "bp", "ep", 
  "optangle", "angle", "value", "vvalue", "numberof", "coord", 
  "initGlobal", "initLocal", "include", "shape", "@1", "@2", "polyNodes", 
  "polyNode", "aRads", "aRad", "processAnnulus", "generalComment", "@3", 
  "shapeComment", "@4", 0
};
#endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives. */
static const short yyr1[] =
{
       0,    29,    30,    30,    31,    31,    31,    31,    31,    32,
      32,    33,    33,    34,    34,    35,    35,    36,    36,    37,
      37,    38,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    46,    46,    47,    47,    47,    47,    48,    47,    47,
      47,    49,    47,    47,    47,    47,    50,    50,    51,    52,
      52,    53,    54,    56,    55,    57,    58,    57
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN. */
static const short yyr2[] =
{
       0,     3,     3,     2,     0,     2,     1,     3,     1,     1,
       1,     1,     1,     1,     1,     0,     1,     0,     1,     0,
       1,     0,     1,     1,     1,     3,     3,     3,     0,     0,
       0,     1,     1,     7,     9,     9,     9,     0,     6,     5,
       9,     0,    12,    11,    18,    18,     3,     1,     1,     3,
       1,     1,     0,     0,     3,     1,     0,     4
};

/* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
   doesn't specify something else to do.  Zero means the default is an
   error. */
static const short yydefact[] =
{
      28,    29,     0,     6,    53,    29,     0,    30,     8,    14,
      13,     5,     0,     0,     1,     9,    10,     3,    31,    32,
       0,    54,     2,    17,    17,    17,    17,    17,    37,    17,
       7,    18,     0,     0,     0,     0,     0,    17,     0,    12,
      11,    15,    15,    15,    15,    15,    19,     0,    15,    16,
       0,     0,     0,     0,     0,    20,    52,    48,    19,    47,
       0,    27,    24,    15,    15,    15,    19,    15,    56,    55,
      39,     0,    52,    15,     0,     0,    21,    52,    21,     0,
      46,    38,    21,    15,    25,    23,    19,    22,    33,    19,
      52,    19,    41,    52,    52,    52,    57,    52,     0,    19,
       0,    40,     0,    35,     0,    34,    36,     0,    52,    51,
      19,    50,     0,     0,    26,    43,     0,    52,    17,    17,
      49,    42,     0,     0,    15,    15,     0,     0,    15,    15,
      21,    21,    19,    19,    45,    44,     0,     0,     0
};

static const short yydefgoto[] =
{
     136,     5,     6,    17,    41,    11,    50,    32,    56,    86,
      87,   109,    65,    99,    57,     1,     7,    20,    30,    37,
     100,    58,    59,   110,   111,    69,     8,    12,    70,    79
};

static const short yypact[] =
{
  -32768,    13,    60,-32768,-32768,   116,    17,    66,-32768,-32768,
  -32768,-32768,    16,    17,-32768,-32768,-32768,-32768,-32768,-32768,
     131,-32768,-32768,    29,    29,    29,    29,    29,-32768,    29,
  -32768,-32768,    83,    83,    83,    83,    83,    29,    83,-32768,
  -32768,    32,    32,    32,    32,    32,    33,    83,    32,-32768,
      83,    83,    83,    83,    83,-32768,    31,-32768,    62,-32768,
      83,-32768,-32768,    32,    32,    32,    33,    32,-32768,-32768,
  -32768,    83,    31,    32,    83,    83,    83,    31,    83,    52,
  -32768,-32768,    83,     6,-32768,-32768,    33,-32768,-32768,    33,
  -32768,    33,    51,    31,     1,    23,-32768,    31,    47,    33,
      83,-32768,    49,-32768,    56,-32768,-32768,    71,    31,-32768,
      62,-32768,    91,    92,-32768,-32768,    83,    31,    29,    29,
  -32768,-32768,    83,    83,    32,    32,    83,    83,    32,    32,
      83,    83,    33,    33,-32768,-32768,   106,   107,-32768
};

static const short yypgoto[] =
{
  -32768,-32768,   105,    99,    -7,-32768,   -25,   -24,    22,   -67,
  -32768,   -37,     0,-32768,   -26,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,    43,-32768,     2,    -1,-32768,-32768,   -16,-32768
};


#define	YYLAST		155


static const short yytable[] =
{
      33,    34,    35,    36,    14,    38,    42,    43,    44,    45,
      46,    89,    48,    47,    63,    91,    66,    51,    52,    53,
      54,    21,     2,    60,   -19,   -19,    49,   102,    55,    68,
       3,    -4,    -4,    71,   -19,    15,    16,    83,    74,    75,
      76,     4,    78,    61,    62,    64,    62,    64,    82,   104,
      31,    68,    49,    64,    67,    55,    81,    90,    92,    68,
      73,    88,    98,   132,   133,   -15,   -15,    62,    84,    85,
     107,    85,     9,    10,   114,    85,   112,   101,   103,   105,
      72,   106,    49,   113,    55,   116,    39,    40,    77,    96,
      18,    19,   115,    62,   122,   123,   124,   125,   118,   126,
     127,   121,   119,   130,   131,    93,   137,   138,    94,    62,
      13,    95,    22,    97,    80,     0,   -52,     0,   120,    64,
      64,   108,     0,    85,    85,     2,   128,   129,     0,     0,
       0,     0,   117,     3,    -4,    -4,     0,    23,    24,    25,
       0,    26,     0,     0,     4,    27,    28,    29,     0,     0,
       0,     0,     0,     0,   134,   135
};

static const short yycheck[] =
{
      24,    25,    26,    27,     5,    29,    32,    33,    34,    35,
      36,    78,    38,    37,    51,    82,    53,    42,    43,    44,
      45,     5,     9,    48,    18,    19,    20,    26,    22,    28,
      17,    18,    19,    58,    28,    18,    19,    74,    63,    64,
      65,    28,    67,    50,    51,    52,    53,    54,    73,    26,
      21,    28,    20,    60,    54,    22,    72,     5,    83,    28,
      60,    77,    11,   130,   131,     3,     4,    74,    75,    76,
      23,    78,    12,    13,     3,    82,    27,    93,    94,    95,
      58,    97,    20,    27,    22,   110,     3,     4,    66,    90,
      24,    25,   108,   100,   118,   119,   122,   123,     7,   124,
     125,   117,    10,   128,   129,    83,     0,     0,    86,   116,
       5,    89,    13,    91,    71,    -1,     0,    -1,   116,   126,
     127,    99,    -1,   130,   131,     9,   126,   127,    -1,    -1,
      -1,    -1,   110,    17,    18,    19,    -1,     6,     7,     8,
      -1,    10,    -1,    -1,    28,    14,    15,    16,    -1,    -1,
      -1,    -1,    -1,    -1,   132,   133
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison/bison.simple"

/* Skeleton output parser for bison,

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software
   Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser when
   the %semantic_parser declaration is not specified in the grammar.
   It was written by Richard Stallman by simplifying the hairy parser
   used when %semantic_parser is specified.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

#if ! defined (yyoverflow) || defined (YYERROR_VERBOSE)

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || defined (YYERROR_VERBOSE) */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYLTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
# if YYLSP_NEEDED
  YYLTYPE yyls;
# endif
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAX (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# if YYLSP_NEEDED
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE) + sizeof (YYLTYPE))	\
      + 2 * YYSTACK_GAP_MAX)
# else
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAX)
# endif

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAX;	\
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif


#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");			\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).

   When YYLLOC_DEFAULT is run, CURRENT is set the location of the
   first token.  By default, to implement support for ranges, extend
   its range to the last symbol.  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)       	\
   Current.last_line   = Rhs[N].last_line;	\
   Current.last_column = Rhs[N].last_column;
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#if YYPURE
# if YYLSP_NEEDED
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, &yylloc, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval, &yylloc)
#  endif
# else /* !YYLSP_NEEDED */
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval)
#  endif
# endif /* !YYLSP_NEEDED */
#else /* !YYPURE */
# define YYLEX			yylex ()
#endif /* !YYPURE */


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)
/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif

#ifdef YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif
#endif

#line 315 "/usr/share/bison/bison.simple"


/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
#  define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL
# else
#  define YYPARSE_PARAM_ARG YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
# endif
#else /* !YYPARSE_PARAM */
# define YYPARSE_PARAM_ARG
# define YYPARSE_PARAM_DECL
#endif /* !YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
# ifdef YYPARSE_PARAM
int yyparse (void *);
# else
int yyparse (void);
# endif
#endif

/* YY_DECL_VARIABLES -- depending whether we use a pure parser,
   variables are global, or local to YYPARSE.  */

#define YY_DECL_NON_LSP_VARIABLES			\
/* The lookahead symbol.  */				\
int yychar;						\
							\
/* The semantic value of the lookahead symbol. */	\
YYSTYPE yylval;						\
							\
/* Number of parse errors so far.  */			\
int yynerrs;

#if YYLSP_NEEDED
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES			\
						\
/* Location data for the lookahead symbol.  */	\
YYLTYPE yylloc;
#else
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES
#endif


/* If nonreentrant, generate the variables here. */

#if !YYPURE
YY_DECL_VARIABLES
#endif  /* !YYPURE */

int
yyparse (YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  /* If reentrant, generate the variables here. */
#if YYPURE
  YY_DECL_VARIABLES
#endif  /* !YYPURE */

  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yychar1 = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack. */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;

#if YYLSP_NEEDED
  /* The location stack.  */
  YYLTYPE yylsa[YYINITDEPTH];
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
#endif

#if YYLSP_NEEDED
# define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
# define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  YYSIZE_T yystacksize = YYINITDEPTH;


  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
#if YYLSP_NEEDED
  YYLTYPE yyloc;
#endif

  /* When reducing, the number of symbols on the RHS of the reduced
     rule. */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;
#if YYLSP_NEEDED
  yylsp = yyls;
#endif
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  */
# if YYLSP_NEEDED
	YYLTYPE *yyls1 = yyls;
	/* This used to be a conditional around just the two extra args,
	   but that might be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);
	yyls = yyls1;
# else
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);
# endif
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);
# if YYLSP_NEEDED
	YYSTACK_RELOCATE (yyls);
# endif
# undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
#if YYLSP_NEEDED
      yylsp = yyls + yysize - 1;
#endif

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yychar1 = YYTRANSLATE (yychar);

#if YYDEBUG
     /* We have to keep this `#if YYDEBUG', since we use variables
	which are defined only if `YYDEBUG' is set.  */
      if (yydebug)
	{
	  YYFPRINTF (stderr, "Next token is %d (%s",
		     yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise
	     meaning of a token, for further debugging info.  */
# ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
# endif
	  YYFPRINTF (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %d (%s), ",
	      yychar, yytname[yychar1]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to the semantic value of
     the lookahead token.  This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

#if YYLSP_NEEDED
  /* Similarly for the default location.  Let the user run additional
     commands if for instance locations are ranges.  */
  yyloc = yylsp[1-yylen];
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
#endif

#if YYDEBUG
  /* We have to keep this `#if YYDEBUG', since we use variables which
     are defined only if `YYDEBUG' is set.  */
  if (yydebug)
    {
      int yyi;

      YYFPRINTF (stderr, "Reducing via rule %d (line %d), ",
		 yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (yyi = yyprhs[yyn]; yyrhs[yyi] > 0; yyi++)
	YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
      YYFPRINTF (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif

  switch (yyn) {

case 6:
#line 99 "saoparser.Y"
{cerr << "SAOimage" << endl;;
    break;}
case 11:
#line 108 "saoparser.Y"
{yyval.real=yyvsp[0].real;;
    break;}
case 12:
#line 109 "saoparser.Y"
{yyval.real=yyvsp[0].integer;;
    break;}
case 13:
#line 112 "saoparser.Y"
{yydebug=1;;
    break;}
case 14:
#line 113 "saoparser.Y"
{yydebug=0;;
    break;}
case 21:
#line 128 "saoparser.Y"
{yyval.real = 0;;
    break;}
case 22:
#line 129 "saoparser.Y"
{yyval.real = yyvsp[0].real;;
    break;}
case 23:
#line 132 "saoparser.Y"
{yyval.real = degToRad(yyvsp[0].real);;
    break;}
case 24:
#line 135 "saoparser.Y"
{yyval.real = FITSPTR->mapLenToRef(yyvsp[0].real, IMAGE);;
    break;}
case 25:
#line 139 "saoparser.Y"
{
	  Vector r = FITSPTR->mapLenToRef(Vector(yyvsp[-2].real,yyvsp[0].real), IMAGE);
	  yyval.vector[0] = r[0];
	  yyval.vector[1] = r[1];
	  yyval.vector[2] = r[2];
	;
    break;}
case 26:
#line 147 "saoparser.Y"
{yyval.integer = yyvsp[0].integer;;
    break;}
case 27:
#line 151 "saoparser.Y"
{
	  Vector r = FITSPTR->mapToRef(Vector(yyvsp[-2].real,yyvsp[0].real), IMAGE);
	  yyval.vector[0] = r[0];
	  yyval.vector[1] = r[1];
	  yyval.vector[2] = r[2];
	;
    break;}
case 28:
#line 159 "saoparser.Y"
{
	  globalProps =
	    Marker::SELECT | Marker::EDIT | Marker::MOVE |
	    Marker::ROTATE | Marker::DELETE | Marker::HIGHLITE |
	    Marker::INCLUDE | Marker::SOURCE;
	;
    break;}
case 29:
#line 167 "saoparser.Y"
{localProps = globalProps;;
    break;}
case 30:
#line 170 "saoparser.Y"
{setProps(&localProps, Marker::INCLUDE, 1);;
    break;}
case 31:
#line 171 "saoparser.Y"
{setProps(&localProps, Marker::INCLUDE, 1);;
    break;}
case 32:
#line 172 "saoparser.Y"
{setProps(&localProps, Marker::INCLUDE, 0);;
    break;}
case 33:
#line 176 "saoparser.Y"
{FR->createCircleCmd(Vector(yyvsp[-4].vector),yyvsp[-2].real,
	    color,1,font,text,localProps,localComment,taglist);;
    break;}
case 34:
#line 180 "saoparser.Y"
{
	  // for ellipse annulus
	  aStatus = 1;
	  aCenter = Vector(yyvsp[-6].vector);
	  aAngle = yyvsp[-2].real;
	  aVector[0] = Vector(yyvsp[-4].vector);
	  aNum = 1;
	  strncpy(aComment,localComment,80);
	  aProps = localProps;

	  FR->createEllipseCmd(Vector(yyvsp[-6].vector),Vector(yyvsp[-4].vector),yyvsp[-2].real,
	  color,1,font,text,localProps,localComment,taglist);
	;
    break;}
case 35:
#line 195 "saoparser.Y"
{
	  // for box annulus
	  aStatus = 3;
	  aCenter = Vector(yyvsp[-6].vector);
	  aAngle = yyvsp[-2].real;
	  aVector[0] = Vector(yyvsp[-4].vector);
	  aNum = 1;
	  strncpy(aComment,localComment,80);
	  aProps = localProps;

	  FR->createBoxCmd(Vector(yyvsp[-6].vector),Vector(yyvsp[-4].vector),yyvsp[-2].real,
	    color,1,font,text,localProps,localComment,taglist);
	;
    break;}
case 36:
#line 209 "saoparser.Y"
{FR->createBoxCmd(Vector(yyvsp[-6].vector),Vector(yyvsp[-4].vector),yyvsp[-2].real,
	    color,1,font,text,localProps,localComment,taglist);;
    break;}
case 37:
#line 212 "saoparser.Y"
{polylist.deleteAll();;
    break;}
case 38:
#line 213 "saoparser.Y"
{FR->createPolygonCmd(polylist,color,1,font,
	      text,localProps,localComment,taglist);;
    break;}
case 39:
#line 217 "saoparser.Y"
{FR->createBoxCirclePointCmd(Vector(yyvsp[-2].vector),
	    color,1,font,text,localProps,localComment,taglist);;
    break;}
case 40:
#line 221 "saoparser.Y"
{FR->createAnnulusCmd(Vector(yyvsp[-6].vector),yyvsp[-4].real,yyvsp[-2].real,1,
	    color,1,font,text,localProps,localComment,taglist);;
    break;}
case 41:
#line 223 "saoparser.Y"
{aNum=2;;
    break;}
case 42:
#line 225 "saoparser.Y"
{
	  aAnnuli[0] = yyvsp[-7].real;
	  aAnnuli[1] = yyvsp[-5].real;
	  FR->createAnnulusCmd(Vector(yyvsp[-9].vector),aAnnuli,aNum,
	  color,1,font,text,localProps,localComment,taglist);
	;
    break;}
case 43:
#line 232 "saoparser.Y"
{FR->createAnnulusCmd(Vector(yyvsp[-8].vector),yyvsp[-6].real,yyvsp[-4].real,yyvsp[-2].integer,
	    color,1,font,text,localProps,localComment,taglist);;
    break;}
case 44:
#line 237 "saoparser.Y"
{	
	  aStatus = 2;
	  aVector[aNum++] = Vector(yyvsp[-13].vector);
	;
    break;}
case 45:
#line 244 "saoparser.Y"
{	
	  aStatus = 4;
	  aVector[aNum++] = Vector(yyvsp[-13].vector);
	;
    break;}
case 48:
#line 254 "saoparser.Y"
{polylist.append(new Vertex(yyvsp[0].vector));;
    break;}
case 51:
#line 261 "saoparser.Y"
{aAnnuli[aNum++] = yyvsp[0].real;;
    break;}
case 52:
#line 265 "saoparser.Y"
{
	  switch (aStatus) {
	  case 0: // do nothing
	    break;
	  case 1: // we found just an ellipse, do nothing
	    break;
	  case 2: // ok we have an ellipse annulus
	    FR->markerDeleteLastCmd(); // delete the previous ellipse
	    FR->createEllipseAnnulusCmd(aCenter,aAngle,aNum,aVector,
	      color,1,font,text,aProps,aComment,taglist);
	    break;
	  case 3: // we found just a box, do nothing
	    break;
	  case 4: // ok, we have a box annulus
	    FR->markerDeleteLastCmd(); // delete the previous box
	    FR->createBoxAnnulusCmd(aCenter,aAngle,aNum,aVector,
	      color,1,font,text,aProps,aComment,taglist);
	    break;
	  }
	  aStatus = 0;
	;
    break;}
case 53:
#line 288 "saoparser.Y"
{DISCARD_(1);
    break;}
case 56:
#line 292 "saoparser.Y"
{DISCARD_(0);
    break;}
case 57:
#line 293 "saoparser.Y"
{strncpy(localComment,yyvsp[-1].str,80);;
    break;}
}

#line 705 "/usr/share/bison/bison.simple"


  yyvsp -= yylen;
  yyssp -= yylen;
#if YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;
#if YYLSP_NEEDED
  *++yylsp = yyloc;
#endif

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("parse error, unexpected ") + 1;
	  yysize += yystrlen (yytname[YYTRANSLATE (yychar)]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "parse error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[YYTRANSLATE (yychar)]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exhausted");
	}
      else
#endif /* defined (YYERROR_VERBOSE) */
	yyerror ("parse error");
    }
  goto yyerrlab1;


/*--------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action |
`--------------------------------------------------*/
yyerrlab1:
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;
      YYDPRINTF ((stderr, "Discarding token %d (%s).\n",
		  yychar, yytname[yychar1]));
      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;


/*-------------------------------------------------------------------.
| yyerrdefault -- current state does not do anything special for the |
| error token.                                                       |
`-------------------------------------------------------------------*/
yyerrdefault:
#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */

  /* If its default is to accept any token, ok.  Otherwise pop it.  */
  yyn = yydefact[yystate];
  if (yyn)
    goto yydefault;
#endif


/*---------------------------------------------------------------.
| yyerrpop -- pop the current state because it cannot handle the |
| error token                                                    |
`---------------------------------------------------------------*/
yyerrpop:
  if (yyssp == yyss)
    YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#if YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "Error: state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

/*--------------.
| yyerrhandle.  |
`--------------*/
yyerrhandle:
  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

/*---------------------------------------------.
| yyoverflowab -- parser overflow comes here.  |
`---------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}
#line 296 "saoparser.Y"


static void setProps(unsigned short* props, unsigned short prop, int value)
{
  if (value)
    *props |= prop;
  else
    *props &= ~prop;
}
