/* A Bison parser, made from tngparser.Y
   by GNU bison 1.35.  */

#define YYBISON 1  /* Identify Bison output.  */

#define yyparse tngparse
#define yylex tnglex
#define yyerror tngerror
#define yylval tnglval
#define yychar tngchar
#define yydebug tngdebug
#define yynerrs tngnerrs
# define	INT	257
# define	REAL	258
# define	STRING	259
# define	DEGREE	260
# define	SEXSTR	261
# define	BACKGROUND_	262
# define	BOX_	263
# define	BLACK_	264
# define	BLUE_	265
# define	CIRCLE_	266
# define	CYAN_	267
# define	DATE_	268
# define	DEBUG_	269
# define	DEGREES_	270
# define	ECLIPTIC_	271
# define	ELLIPSE_	272
# define	FILENAME_	273
# define	FK4_	274
# define	FK5_	275
# define	FORMAT_	276
# define	GALACTIC_	277
# define	GREEN_	278
# define	HMS_	279
# define	ICRS_	280
# define	LINE_	281
# define	MAGENTA_	282
# define	OFF_	283
# define	ON_	284
# define	PHYSICAL_	285
# define	PIXELS_	286
# define	POINT_	287
# define	POLYGON_	288
# define	RED_	289
# define	SOURCE_	290
# define	TEXT_	291
# define	VERSION_	292
# define	WHITE_	293
# define	YELLOW_	294

#line 5 "tngparser.Y"

#define YYPARSE_PARAM fr
#define YYDEBUG 1

#define FR ((FrameBase*)fr)
#define FITSPTR (FR->findFits(1))

#define DISCARD_(x) {yyclearin; tngDiscard(x);}

#include <math.h>
#include <string.h>
#include <iostream.h>

#include "framebase.h"
#include "fitsimage.h"
#include "util.h"
#include "vector.h"
#include "list.h"
#include "basemarker.h"
#include "coord.h"

extern int tnglex(void);
extern void tngerror(const char*);
extern void tngDiscard(int);

int tngsign;
int tngsign2;

static CoordSystem globalSystem;
static SkyFrame globalSky;
static CoordSystem localSystem;
static SkyFrame localSky;

static unsigned short globalProps;
static unsigned short localProps;

static char globalColor[16];
static char localColor[16];

static char globalFont[32];

static char globalText[80];
static char localText[80];

static char localComment[80];

static List<Vertex> polylist;
static List<Tag> taglist;

static void setProps(unsigned short* props, unsigned short prop, int value);
static CoordSystem checkWCSSystem();
static SkyFrame checkWCSSky();

#line 59 "tngparser.Y"
#ifndef YYSTYPE
typedef union {
  double real;
  int integer;
  char str[256];
  double vector[3];
} yystype;
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif
#ifndef YYDEBUG
# define YYDEBUG 0
#endif



#define	YYFINAL		142
#define	YYFLAG		-32768
#define	YYNTBASE	50

/* YYTRANSLATE(YYLEX) -- Bison token number corresponding to YYLEX. */
#define YYTRANSLATE(x) ((unsigned)(x) <= 294 ? yytranslate[x] : 82)

/* YYTRANSLATE[YYLEX] -- Bison token number corresponding to YYLEX. */
static const char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      41,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,    48,     2,     2,     2,     2,
      44,    45,     2,    46,    43,    47,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    49,    42,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40
};

#if YYDEBUG
static const short yyprhs[] =
{
       0,     0,     3,     7,    10,    11,    14,    16,    20,    22,
      24,    26,    28,    30,    32,    34,    35,    37,    38,    40,
      41,    43,    44,    46,    48,    50,    52,    56,    58,    62,
      66,    70,    72,    74,    76,    78,    80,    81,    82,    83,
      85,    87,    95,   105,   115,   116,   123,   131,   132,   141,
     147,   151,   153,   155,   160,   161,   167,   168,   174,   175,
     179,   180,   183,   186,   189,   192,   195,   198,   201,   204,
     207,   210,   211,   215,   218,   221,   223,   228,   229
};
static const short yyrhs[] =
{
      66,    51,     0,    51,    52,    53,     0,    52,    53,     0,
       0,    15,    55,     0,    38,     0,    67,    68,    69,     0,
      74,     0,    41,     0,    42,     0,     4,     0,     3,     0,
      30,     0,    29,     0,     0,    43,     0,     0,    44,     0,
       0,    45,     0,     0,    60,     0,    54,     0,     6,     0,
      54,     0,    54,    56,    54,     0,     7,     0,    63,    56,
      63,     0,    54,    56,    54,     0,     6,    56,     6,     0,
      20,     0,    21,     0,    23,     0,    17,     0,    26,     0,
       0,     0,     0,    46,     0,    47,     0,    12,    57,    64,
      56,    61,    58,    78,     0,    18,    57,    64,    56,    62,
      56,    59,    58,    78,     0,     9,    57,    64,    56,    62,
      56,    59,    58,    78,     0,     0,    34,    70,    57,    72,
      58,    78,     0,    27,    57,    64,    56,    64,    58,    78,
       0,     0,    37,    57,    64,    56,     5,    58,    71,    78,
       0,    33,    57,    64,    58,    78,     0,    72,    56,    73,
       0,    73,     0,    64,     0,    48,    22,    49,    80,     0,
       0,    48,    19,    49,    75,     5,     0,     0,    48,    14,
      49,    76,     5,     0,     0,    48,    77,     5,     0,     0,
      48,    39,     0,    48,    10,     0,    48,    35,     0,    48,
      24,     0,    48,    11,     0,    48,    13,     0,    48,    28,
       0,    48,    40,     0,    48,    36,     0,    48,     8,     0,
       0,    48,    79,     5,     0,    25,    81,     0,    16,    81,
       0,    32,     0,    32,    44,    31,    45,     0,     0,    44,
      65,    45,     0
};

#endif

#if YYDEBUG
/* YYRLINE[YYN] -- source line where rule number YYN was defined. */
static const short yyrline[] =
{
       0,   120,   123,   124,   127,   128,   129,   130,   131,   134,
     135,   138,   139,   142,   143,   146,   147,   150,   151,   154,
     155,   158,   159,   162,   163,   166,   169,   178,   181,   195,
     202,   212,   213,   214,   215,   216,   219,   233,   246,   247,
     248,   251,   256,   261,   266,   266,   270,   275,   275,   280,
     286,   287,   290,   293,   294,   294,   295,   295,   296,   296,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     313,   318,   318,   321,   322,   323,   324,   327,   332
};
#endif


#if (YYDEBUG) || defined YYERROR_VERBOSE

/* YYTNAME[TOKEN_NUM] -- String name of the token TOKEN_NUM. */
static const char *const yytname[] =
{
  "$", "error", "$undefined.", "INT", "REAL", "STRING", "DEGREE", "SEXSTR", 
  "BACKGROUND_", "BOX_", "BLACK_", "BLUE_", "CIRCLE_", "CYAN_", "DATE_", 
  "DEBUG_", "DEGREES_", "ECLIPTIC_", "ELLIPSE_", "FILENAME_", "FK4_", 
  "FK5_", "FORMAT_", "GALACTIC_", "GREEN_", "HMS_", "ICRS_", "LINE_", 
  "MAGENTA_", "OFF_", "ON_", "PHYSICAL_", "PIXELS_", "POINT_", "POLYGON_", 
  "RED_", "SOURCE_", "TEXT_", "VERSION_", "WHITE_", "YELLOW_", "'\\n'", 
  "';'", "','", "'('", "')'", "'+'", "'-'", "'#'", "':'", "start", 
  "commands", "command", "terminator", "numeric", "debug", "sp", "bp", 
  "ep", "optangle", "angle", "value", "vvalue", "sexagesimal", "coord", 
  "skyFrame", "initGlobal", "initLocal", "include", "shape", "@1", "@2", 
  "polyNodes", "polyNode", "generalComment", "@3", "@4", "@5", 
  "shapeComment", "@6", "tngFormat", "tngWCS", 0
};
#endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives. */
static const short yyr1[] =
{
       0,    50,    51,    51,    52,    52,    52,    52,    52,    53,
      53,    54,    54,    55,    55,    56,    56,    57,    57,    58,
      58,    59,    59,    60,    60,    61,    62,    63,    64,    64,
      64,    65,    65,    65,    65,    65,    66,    67,    68,    68,
      68,    69,    69,    69,    70,    69,    69,    71,    69,    69,
      72,    72,    73,    74,    75,    74,    76,    74,    77,    74,
      78,    78,    78,    78,    78,    78,    78,    78,    78,    78,
      78,    79,    78,    80,    80,    80,    80,    81,    81
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN. */
static const short yyr2[] =
{
       0,     2,     3,     2,     0,     2,     1,     3,     1,     1,
       1,     1,     1,     1,     1,     0,     1,     0,     1,     0,
       1,     0,     1,     1,     1,     1,     3,     1,     3,     3,
       3,     1,     1,     1,     1,     1,     0,     0,     0,     1,
       1,     7,     9,     9,     0,     6,     7,     0,     8,     5,
       3,     1,     1,     4,     0,     5,     0,     5,     0,     3,
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     0,     3,     2,     2,     1,     4,     0,     3
};

/* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
   doesn't specify something else to do.  Zero means the default is an
   error. */
static const short yydefact[] =
{
      36,    37,     0,     6,    58,    37,     0,    38,     8,    14,
      13,     5,     0,     0,     0,     0,     0,     9,    10,     3,
      39,    40,     0,    56,    54,     0,    59,     2,    17,    17,
      17,    17,    17,    44,    17,     7,     0,     0,    77,    77,
      75,    53,    18,     0,     0,     0,     0,     0,    17,     0,
      57,    55,     0,    74,    73,     0,    12,    11,    15,    27,
      15,    15,    15,    15,    15,    15,    19,     0,    15,    34,
      31,    32,    33,    35,     0,     0,    16,     0,     0,     0,
       0,     0,     0,     0,    20,    60,    52,    15,    51,     0,
      78,    76,    30,    29,    28,    15,    15,    25,    19,    15,
      19,    71,    49,     0,    60,    19,     0,    21,    60,    21,
      60,    70,    62,    65,    66,    64,    67,    63,    69,    61,
      68,     0,    50,    45,    47,    26,    24,    23,    19,    22,
      41,    19,    46,    72,    60,    60,    60,    48,    43,    42,
       0,     0,     0
};

static const short yydefgoto[] =
{
     140,     5,     6,    19,    60,    11,    77,    43,    85,   128,
     129,    98,    96,    61,    86,    74,     1,     7,    22,    35,
      48,   134,    87,    88,     8,    37,    36,    15,   102,   121,
      41,    53
};

static const short yypact[] =
{
  -32768,    -5,   -28,-32768,    56,     0,   -24,    -7,-32768,-32768,
  -32768,-32768,   -30,   -27,    -3,     7,   -24,-32768,-32768,-32768,
  -32768,-32768,    73,-32768,-32768,   -12,-32768,-32768,     9,     9,
       9,     9,     9,-32768,     9,-32768,    50,    51,    16,    16,
      27,-32768,-32768,   118,   118,   118,   118,   118,     9,   118,
  -32768,-32768,    88,-32768,-32768,    42,-32768,-32768,    29,-32768,
      29,    29,    29,    29,    29,    29,    34,   118,    29,-32768,
  -32768,-32768,-32768,-32768,    38,    39,-32768,    68,    31,    79,
      31,    31,    31,   118,-32768,    46,-32768,    75,-32768,    85,
  -32768,-32768,-32768,-32768,-32768,    29,    29,-32768,    34,    29,
      34,    41,-32768,   118,    46,    34,    31,    26,    46,    26,
      46,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,    97,-32768,-32768,-32768,-32768,-32768,-32768,    34,-32768,
  -32768,    34,-32768,-32768,    46,    46,    46,-32768,-32768,-32768,
     103,   104,-32768
};

static const short yypgoto[] =
{
  -32768,-32768,   107,   110,   -14,-32768,   -37,    67,   -84,     4,
  -32768,-32768,    37,    48,   -38,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,    25,-32768,-32768,-32768,-32768,   -47,-32768,
  -32768,    90
};


#define	YYLAST		129


static const short yytable[] =
{
      -1,     9,    10,   104,    38,    62,    63,    64,    65,    66,
       2,    68,    26,    39,   108,     2,   110,    17,    18,    23,
      40,   124,    24,    78,    79,    80,    81,    82,    83,    56,
      57,    89,   126,     3,    56,    57,    -4,    -4,     3,    20,
      21,    -4,    -4,     4,   135,   100,    25,   136,     4,   111,
     103,   112,   113,    42,   114,    50,    51,   123,   106,   107,
      52,   130,   109,   132,    93,   115,    95,    97,    95,   116,
      12,    55,    76,    75,    92,    13,   117,   118,    14,    84,
     119,   120,    28,    90,    91,    29,    59,   137,   138,   139,
     105,    30,   125,   127,   101,   127,    44,    45,    46,    47,
      31,    49,   133,   141,   142,    69,    32,    33,    70,    71,
      34,    72,    16,   131,    73,    67,   -19,   -19,    76,    99,
      84,    56,    57,   -19,    58,    59,    27,    94,   122,    54
};

static const short yycheck[] =
{
       0,    29,    30,    87,    16,    43,    44,    45,    46,    47,
      15,    49,     5,    25,    98,    15,   100,    41,    42,    49,
      32,   105,    49,    60,    61,    62,    63,    64,    65,     3,
       4,    68,     6,    38,     3,     4,    41,    42,    38,    46,
      47,    41,    42,    48,   128,    83,    49,   131,    48,     8,
      87,    10,    11,    44,    13,     5,     5,   104,    95,    96,
      44,   108,    99,   110,    78,    24,    80,    81,    82,    28,
      14,    44,    43,    31,     6,    19,    35,    36,    22,    45,
      39,    40,     9,    45,    45,    12,     7,   134,   135,   136,
       5,    18,   106,   107,    48,   109,    29,    30,    31,    32,
      27,    34,     5,     0,     0,    17,    33,    34,    20,    21,
      37,    23,     5,   109,    26,    48,    41,    42,    43,    82,
      45,     3,     4,    48,     6,     7,    16,    79,   103,    39
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison/bison.simple"

/* Skeleton output parser for bison,

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software
   Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser when
   the %semantic_parser declaration is not specified in the grammar.
   It was written by Richard Stallman by simplifying the hairy parser
   used when %semantic_parser is specified.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

#if ! defined (yyoverflow) || defined (YYERROR_VERBOSE)

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || defined (YYERROR_VERBOSE) */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYLTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
# if YYLSP_NEEDED
  YYLTYPE yyls;
# endif
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAX (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# if YYLSP_NEEDED
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE) + sizeof (YYLTYPE))	\
      + 2 * YYSTACK_GAP_MAX)
# else
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAX)
# endif

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAX;	\
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif


#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");			\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).

   When YYLLOC_DEFAULT is run, CURRENT is set the location of the
   first token.  By default, to implement support for ranges, extend
   its range to the last symbol.  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)       	\
   Current.last_line   = Rhs[N].last_line;	\
   Current.last_column = Rhs[N].last_column;
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#if YYPURE
# if YYLSP_NEEDED
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, &yylloc, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval, &yylloc)
#  endif
# else /* !YYLSP_NEEDED */
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval)
#  endif
# endif /* !YYLSP_NEEDED */
#else /* !YYPURE */
# define YYLEX			yylex ()
#endif /* !YYPURE */


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)
/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif

#ifdef YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif
#endif

#line 315 "/usr/share/bison/bison.simple"


/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
#  define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL
# else
#  define YYPARSE_PARAM_ARG YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
# endif
#else /* !YYPARSE_PARAM */
# define YYPARSE_PARAM_ARG
# define YYPARSE_PARAM_DECL
#endif /* !YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
# ifdef YYPARSE_PARAM
int yyparse (void *);
# else
int yyparse (void);
# endif
#endif

/* YY_DECL_VARIABLES -- depending whether we use a pure parser,
   variables are global, or local to YYPARSE.  */

#define YY_DECL_NON_LSP_VARIABLES			\
/* The lookahead symbol.  */				\
int yychar;						\
							\
/* The semantic value of the lookahead symbol. */	\
YYSTYPE yylval;						\
							\
/* Number of parse errors so far.  */			\
int yynerrs;

#if YYLSP_NEEDED
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES			\
						\
/* Location data for the lookahead symbol.  */	\
YYLTYPE yylloc;
#else
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES
#endif


/* If nonreentrant, generate the variables here. */

#if !YYPURE
YY_DECL_VARIABLES
#endif  /* !YYPURE */

int
yyparse (YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  /* If reentrant, generate the variables here. */
#if YYPURE
  YY_DECL_VARIABLES
#endif  /* !YYPURE */

  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yychar1 = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack. */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;

#if YYLSP_NEEDED
  /* The location stack.  */
  YYLTYPE yylsa[YYINITDEPTH];
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
#endif

#if YYLSP_NEEDED
# define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
# define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  YYSIZE_T yystacksize = YYINITDEPTH;


  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
#if YYLSP_NEEDED
  YYLTYPE yyloc;
#endif

  /* When reducing, the number of symbols on the RHS of the reduced
     rule. */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;
#if YYLSP_NEEDED
  yylsp = yyls;
#endif
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  */
# if YYLSP_NEEDED
	YYLTYPE *yyls1 = yyls;
	/* This used to be a conditional around just the two extra args,
	   but that might be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);
	yyls = yyls1;
# else
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);
# endif
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);
# if YYLSP_NEEDED
	YYSTACK_RELOCATE (yyls);
# endif
# undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
#if YYLSP_NEEDED
      yylsp = yyls + yysize - 1;
#endif

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yychar1 = YYTRANSLATE (yychar);

#if YYDEBUG
     /* We have to keep this `#if YYDEBUG', since we use variables
	which are defined only if `YYDEBUG' is set.  */
      if (yydebug)
	{
	  YYFPRINTF (stderr, "Next token is %d (%s",
		     yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise
	     meaning of a token, for further debugging info.  */
# ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
# endif
	  YYFPRINTF (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %d (%s), ",
	      yychar, yytname[yychar1]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to the semantic value of
     the lookahead token.  This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

#if YYLSP_NEEDED
  /* Similarly for the default location.  Let the user run additional
     commands if for instance locations are ranges.  */
  yyloc = yylsp[1-yylen];
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
#endif

#if YYDEBUG
  /* We have to keep this `#if YYDEBUG', since we use variables which
     are defined only if `YYDEBUG' is set.  */
  if (yydebug)
    {
      int yyi;

      YYFPRINTF (stderr, "Reducing via rule %d (line %d), ",
		 yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (yyi = yyprhs[yyn]; yyrhs[yyi] > 0; yyi++)
	YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
      YYFPRINTF (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif

  switch (yyn) {

case 6:
#line 129 "tngparser.Y"
{cerr << "SAOtng" << endl;;
    break;}
case 11:
#line 138 "tngparser.Y"
{yyval.real=yyvsp[0].real;;
    break;}
case 12:
#line 139 "tngparser.Y"
{yyval.real=yyvsp[0].integer;;
    break;}
case 13:
#line 142 "tngparser.Y"
{yydebug=1;;
    break;}
case 14:
#line 143 "tngparser.Y"
{yydebug=0;;
    break;}
case 21:
#line 158 "tngparser.Y"
{yyval.real = 0;;
    break;}
case 22:
#line 159 "tngparser.Y"
{yyval.real = yyvsp[0].real;;
    break;}
case 23:
#line 162 "tngparser.Y"
{yyval.real = degToRad(yyvsp[0].real);;
    break;}
case 24:
#line 163 "tngparser.Y"
{yyval.real = degToRad(yyvsp[0].real);;
    break;}
case 25:
#line 166 "tngparser.Y"
{yyval.real = FITSPTR->mapLenToRef(yyvsp[0].real,IMAGE);;
    break;}
case 26:
#line 170 "tngparser.Y"
{
	  Vector r = FITSPTR->mapLenToRef(Vector(yyvsp[-2].real,yyvsp[0].real), IMAGE);
	  yyval.vector[0] = r[0];
	  yyval.vector[1] = r[1];
	  yyval.vector[2] = r[2];
	;
    break;}
case 27:
#line 178 "tngparser.Y"
{yyval.real = parseDMS(yyvsp[0].str);;
    break;}
case 28:
#line 182 "tngparser.Y"
{
	  Vector r;
	  CoordSystem sys = checkWCSSystem();
	  SkyFrame sky = checkWCSSky();
	  if (sky == GALACTIC || sky == ECLIPTIC) 
	    r = FITSPTR->mapToRef(Vector(yyvsp[-2].real,yyvsp[0].real), sys, sky);
	  else
	    r = FITSPTR->mapToRef(Vector(yyvsp[-2].real*360./24.,yyvsp[0].real), sys, sky);

	  yyval.vector[0] = r[0];
	  yyval.vector[1] = r[1];
	  yyval.vector[2] = r[2];
	;
    break;}
case 29:
#line 196 "tngparser.Y"
{
	  Vector r = FITSPTR->mapToRef(Vector(yyvsp[-2].real,yyvsp[0].real), localSystem, localSky);
	  yyval.vector[0] = r[0];
	  yyval.vector[1] = r[1];
	  yyval.vector[2] = r[2];
	;
    break;}
case 30:
#line 203 "tngparser.Y"
{
	  Vector r = FITSPTR->mapToRef(Vector(yyvsp[-2].real,yyvsp[0].real),
	    checkWCSSystem(), checkWCSSky());
	  yyval.vector[0] = r[0];
	  yyval.vector[1] = r[1];
	  yyval.vector[2] = r[2];
	;
    break;}
case 31:
#line 212 "tngparser.Y"
{yyval.integer = FK4;;
    break;}
case 32:
#line 213 "tngparser.Y"
{yyval.integer = FK5;;
    break;}
case 33:
#line 214 "tngparser.Y"
{yyval.integer = GALACTIC;;
    break;}
case 34:
#line 215 "tngparser.Y"
{yyval.integer = ECLIPTIC;;
    break;}
case 35:
#line 216 "tngparser.Y"
{yyval.integer = ICRS;;
    break;}
case 36:
#line 219 "tngparser.Y"
{
	  // global properties
	  globalSystem = IMAGE;
	  globalSky = NATIVEWCS;
	  globalProps =
	    Marker::SELECT | Marker::EDIT | Marker::MOVE |
	    Marker::ROTATE | Marker::DELETE | Marker::HIGHLITE |
	    Marker::INCLUDE | Marker::SOURCE;
	  strcpy(globalColor,"green");
	  strcpy(globalFont,"helvetica 10 normal");
	  strcpy(globalText,"");
	;
    break;}
case 37:
#line 233 "tngparser.Y"
{
	  // global properties
	  localSystem = globalSystem;
	  localSky = localSky;
	  localProps = globalProps;
	  strcpy(localColor,globalColor);
	  strcpy(localText,globalText);
	  strcpy(localComment,"");

	  strcpy(globalText,"");
	;
    break;}
case 38:
#line 246 "tngparser.Y"
{setProps(&localProps, Marker::INCLUDE, 1);;
    break;}
case 39:
#line 247 "tngparser.Y"
{setProps(&localProps, Marker::INCLUDE, 1);;
    break;}
case 40:
#line 248 "tngparser.Y"
{setProps(&localProps, Marker::INCLUDE, 0);;
    break;}
case 41:
#line 252 "tngparser.Y"
{FR->createCircleCmd(Vector(yyvsp[-4].vector),yyvsp[-2].real,
	    localColor,1,globalFont,localText,localProps,localComment,
	    taglist);;
    break;}
case 42:
#line 257 "tngparser.Y"
{FR->createEllipseCmd(Vector(yyvsp[-6].vector),Vector(yyvsp[-4].vector),yyvsp[-2].real,
	    localColor,1,globalFont,localText,localProps,localComment,
	    taglist);;
    break;}
case 43:
#line 262 "tngparser.Y"
{FR->createBoxCmd(Vector(yyvsp[-6].vector),Vector(yyvsp[-4].vector),yyvsp[-2].real,
	    localColor,1,globalFont,localText,localProps,localComment,
	    taglist);;
    break;}
case 44:
#line 266 "tngparser.Y"
{polylist.deleteAll();;
    break;}
case 45:
#line 267 "tngparser.Y"
{FR->createPolygonCmd(polylist,localColor,1,globalFont,
	      localText,localProps,localComment,taglist);;
    break;}
case 46:
#line 271 "tngparser.Y"
{FR->createLineCmd(Vector(yyvsp[-4].vector),Vector(yyvsp[-2].vector),
	    0,0,localColor,1,globalFont,localText,localProps,localComment,
	    taglist);;
    break;}
case 47:
#line 275 "tngparser.Y"
{strncpy(localText,yyvsp[-1].str,80);;
    break;}
case 48:
#line 276 "tngparser.Y"
{FR->createTextCmd(Vector(yyvsp[-5].vector),0,
	    localColor,1,globalFont,localText,localProps,localComment,
	    taglist);;
    break;}
case 49:
#line 281 "tngparser.Y"
{FR->createBoxCirclePointCmd(Vector(yyvsp[-2].vector),
	    localColor,1,globalFont,localText,localProps,localComment,
	    taglist);;
    break;}
case 52:
#line 290 "tngparser.Y"
{polylist.append(new Vertex(yyvsp[0].vector));;
    break;}
case 54:
#line 294 "tngparser.Y"
{DISCARD_(0);
    break;}
case 56:
#line 295 "tngparser.Y"
{DISCARD_(0);
    break;}
case 58:
#line 296 "tngparser.Y"
{DISCARD_(1);
    break;}
case 59:
#line 296 "tngparser.Y"
{strncpy(globalText,yyvsp[0].str,80);;
    break;}
case 61:
#line 300 "tngparser.Y"
{strcpy(localColor,"white");;
    break;}
case 62:
#line 301 "tngparser.Y"
{strcpy(localColor,"black");;
    break;}
case 63:
#line 302 "tngparser.Y"
{strcpy(localColor,"red");;
    break;}
case 64:
#line 303 "tngparser.Y"
{strcpy(localColor,"green");;
    break;}
case 65:
#line 304 "tngparser.Y"
{strcpy(localColor,"blue");;
    break;}
case 66:
#line 305 "tngparser.Y"
{strcpy(localColor,"cyan");;
    break;}
case 67:
#line 306 "tngparser.Y"
{strcpy(localColor,"magenta");;
    break;}
case 68:
#line 307 "tngparser.Y"
{strcpy(localColor,"yellow");;
    break;}
case 69:
#line 309 "tngparser.Y"
{
	  strcpy(localColor,"green");
	  setProps(&localProps,Marker::SOURCE,1);
	;
    break;}
case 70:
#line 314 "tngparser.Y"
{
	  strcpy(localColor,"red");
	  setProps(&localProps,Marker::SOURCE,0);
	;
    break;}
case 71:
#line 318 "tngparser.Y"
{DISCARD_(1);
    break;}
case 72:
#line 318 "tngparser.Y"
{strncpy(localComment,yyvsp[0].str,80);;
    break;}
case 75:
#line 323 "tngparser.Y"
{globalSystem = localSystem = IMAGE;;
    break;}
case 76:
#line 324 "tngparser.Y"
{globalSystem = localSystem = IMAGE;;
    break;}
case 77:
#line 328 "tngparser.Y"
{
	    globalSystem = localSystem = WCS;
	    globalSky = localSky = NATIVEWCS;
	  ;
    break;}
case 78:
#line 333 "tngparser.Y"
{
	    globalSystem = localSystem = WCS;
	    globalSky = localSky = (SkyFrame)yyvsp[-1].integer;
	  ;
    break;}
}

#line 705 "/usr/share/bison/bison.simple"


  yyvsp -= yylen;
  yyssp -= yylen;
#if YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;
#if YYLSP_NEEDED
  *++yylsp = yyloc;
#endif

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("parse error, unexpected ") + 1;
	  yysize += yystrlen (yytname[YYTRANSLATE (yychar)]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "parse error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[YYTRANSLATE (yychar)]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exhausted");
	}
      else
#endif /* defined (YYERROR_VERBOSE) */
	yyerror ("parse error");
    }
  goto yyerrlab1;


/*--------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action |
`--------------------------------------------------*/
yyerrlab1:
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;
      YYDPRINTF ((stderr, "Discarding token %d (%s).\n",
		  yychar, yytname[yychar1]));
      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;


/*-------------------------------------------------------------------.
| yyerrdefault -- current state does not do anything special for the |
| error token.                                                       |
`-------------------------------------------------------------------*/
yyerrdefault:
#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */

  /* If its default is to accept any token, ok.  Otherwise pop it.  */
  yyn = yydefact[yystate];
  if (yyn)
    goto yydefault;
#endif


/*---------------------------------------------------------------.
| yyerrpop -- pop the current state because it cannot handle the |
| error token                                                    |
`---------------------------------------------------------------*/
yyerrpop:
  if (yyssp == yyss)
    YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#if YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "Error: state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

/*--------------.
| yyerrhandle.  |
`--------------*/
yyerrhandle:
  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

/*---------------------------------------------.
| yyoverflowab -- parser overflow comes here.  |
`---------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}
#line 339 "tngparser.Y"


static void setProps(unsigned short* props, unsigned short prop, int value)
{
  if (value)
    *props |= prop;
  else
    *props &= ~prop;
}

static CoordSystem checkWCSSystem()
{
  switch (localSystem) {
  case IMAGE:
  case PHYSICAL:
    return WCS;
  default:
    return localSystem;
  }
}

static SkyFrame checkWCSSky()
{
  switch (localSystem) {
  case IMAGE:
  case PHYSICAL:
    return NATIVEWCS;
  default:
   return localSky;
  }
}
