# _AC_LANG_COMPILER_GNU33
# ---------------------
# Check whether the C compiler is GNU 3.3 or above.
# Taken directly from _AC_LANG_COMPILER_GNU
#
m4_define([_AC_LANG_COMPILER_GNU33],
[AC_CACHE_CHECK([for GNU C 3.3 or above],
                [ac_cv_c_compiler_gnu33],
[_AC_COMPILE_IFELSE([AC_LANG_PROGRAM([], [[#ifndef __GNUC__
       choke me
#else
#if __GNUC__ < 3
       choke me
#else
#if __GNUC_MINOR__ < 3
       choke me
#endif
#endif
#endif
]])],
                   [ac_compiler_gnu33=yes],
                   [ac_compiler_gnu33=no])
ac_cv_c_compiler_gnu33=$ac_compiler_gnu33
])])# _AC_LANG_COMPILER_GNU33

