#! /bin/sh

echo "Alignment Tests"
echo

echo "test panner,center,zoom"
../ds9 5x5.fits
echo "PASSED"

echo "testing DATASEC"
../ds9 ds9_2amp.fits
echo "PASSED"

echo "testing WCS FK5"
../ds9 -zscale -mosaicimage iraf mosaicimage.fits -mosaicimage wcs mosaicimage.fits -file -rgb mosaicimage.fits[1] -green mosaicimage.fits[2] -blue mosaicimage.fits[3]
echo "PASSED"

echo "testing WCS Linear"
../ds9 -mosaicimage iraf ds9_2amp.fits -mosaicimage wcs ds9_2amp.fits -file -rgb -red ds9_2amp.fits[1] -green ds9_2amp.fits[2]
echo "PASSED"

echo "testing WCS Linear block x2"
../ds9 -mosaicimage iraf ds9_8amp_2x2.fits -mosaicimage wcs ds9_8amp_2x2.fits
echo "PASSED"

echo "testing WCS RGB"
../ds9 -zscale -mosaic wcs m51hst.fits img-32.fits -file -rgb -red m51hst.fits -green img-32.fits
echo "PASSED"

echo "Done"


