#ifndef BISON_CIAOPARSER_H
# define BISON_CIAOPARSER_H

#ifndef YYSTYPE
typedef union {
  double real;
  int integer;
  char str[256];
  double vector[3];
} yystype;
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif
# define	INT	257
# define	REAL	258
# define	HOUR	259
# define	MINUTE	260
# define	SECOND	261
# define	ARCMINUTE	262
# define	ARCSECOND	263
# define	SEXSTR	264
# define	ANNULUS_	265
# define	BOX_	266
# define	CIRCLE_	267
# define	DEBUG_	268
# define	ELLIPSE_	269
# define	OFF_	270
# define	ON_	271
# define	PIE_	272
# define	POINT_	273
# define	POLYGON_	274
# define	ROTBOX_	275
# define	VERSION_	276


extern YYSTYPE ciaolval;

#endif /* not BISON_CIAOPARSER_H */
