#ifndef BISON_DS9PARSER_H
# define BISON_DS9PARSER_H

#ifndef YYSTYPE
typedef union {
  double real;
  int integer;
  char str[256];
  double vector[3];
} yystype;
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif
# define	INT	257
# define	REAL	258
# define	STRING	259
# define	HOUR	260
# define	MINUTE	261
# define	SECOND	262
# define	DEGREE	263
# define	ARCMINUTE	264
# define	ARCSECOND	265
# define	RADIAN	266
# define	PHYCOORD	267
# define	IMGCOORD	268
# define	SEXSTR	269
# define	AMPLIFIER_	270
# define	ANNULUS_	271
# define	ARCMIN_	272
# define	ARCSEC_	273
# define	ARROW_	274
# define	B1950_	275
# define	BACKGROUND_	276
# define	BOX_	277
# define	BOXCIRCLE_	278
# define	CIRCLE_	279
# define	COLOR_	280
# define	COMPASS_	281
# define	CROSS_	282
# define	DEBUG_	283
# define	DEGREES_	284
# define	DELETE_	285
# define	DETECTOR_	286
# define	DIAMOND_	287
# define	ECLIPTIC_	288
# define	EDIT_	289
# define	ELLIPSE_	290
# define	FALSE_	291
# define	FIELD_	292
# define	FIXED_	293
# define	FK4_	294
# define	FK5_	295
# define	FONT_	296
# define	GALACTIC_	297
# define	GLOBAL_	298
# define	HIGHLITE_	299
# define	ICRS_	300
# define	IGNORE_	301
# define	IMAGE_	302
# define	INCLUDE_	303
# define	J2000_	304
# define	LINE_	305
# define	LINEAR_	306
# define	MOVE_	307
# define	N_	308
# define	NO_	309
# define	OFF_	310
# define	ON_	311
# define	PANDA_	312
# define	PHYSICAL_	313
# define	PIE_	314
# define	PIXELS_	315
# define	POINT_	316
# define	POLYGON_	317
# define	PROJECTION_	318
# define	ROTATE_	319
# define	ROTBOX_	320
# define	RULER_	321
# define	SELECT_	322
# define	SOURCE_	323
# define	TAG_	324
# define	TEXT_	325
# define	TEXTANGLE_	326
# define	TILE_	327
# define	TRUE_	328
# define	VERSION_	329
# define	WCS_	330
# define	WCSA_	331
# define	WCSB_	332
# define	WCSC_	333
# define	WCSD_	334
# define	WCSE_	335
# define	WCSF_	336
# define	WCSG_	337
# define	WCSH_	338
# define	WCSI_	339
# define	WCSJ_	340
# define	WCSK_	341
# define	WCSL_	342
# define	WCSM_	343
# define	WCSN_	344
# define	WCSO_	345
# define	WCSP_	346
# define	WCSQ_	347
# define	WCSR_	348
# define	WCSS_	349
# define	WCST_	350
# define	WCSU_	351
# define	WCSV_	352
# define	WCSW_	353
# define	WCSX_	354
# define	WCSY_	355
# define	WCSZ_	356
# define	WIDTH_	357
# define	X_	358
# define	Y_	359
# define	YES_	360


extern YYSTYPE mklval;

#endif /* not BISON_DS9PARSER_H */
