#ifndef BISON_PARSER_H
# define BISON_PARSER_H

#ifndef YYSTYPE
typedef union {
  char chr;
  char str[1024];
  void* ptr;
  int integer;
  double real;
  double vector[3];
} yystype;
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif
# define	REAL	257
# define	INT	258
# define	STRING	259
# define	POINTER	260
# define	HOUR	261
# define	MINUTE	262
# define	SECOND	263
# define	DEGREE	264
# define	ARCMINUTE	265
# define	ARCSECOND	266
# define	RADIAN	267
# define	SEXSTR	268
# define	ABOUT_	269
# define	AIPS_	270
# define	ALLOC_	271
# define	ALLOCGZ_	272
# define	ALIGN_	273
# define	ALL_	274
# define	AMPLIFIER_	275
# define	ANALYSIS_	276
# define	ANGLE_	277
# define	ANNULUS_	278
# define	APPEND_	279
# define	ARCMIN_	280
# define	ARCSEC_	281
# define	AREA_	282
# define	ARRAY_	283
# define	ARROW_	284
# define	AST_	285
# define	AUTO_	286
# define	AVERAGE_	287
# define	B1950_	288
# define	BACK_	289
# define	BASE_	290
# define	BBOX_	291
# define	BEGIN_	292
# define	BG_	293
# define	BIN_	294
# define	BITPIX_	295
# define	BLOCK_	296
# define	BOX_	297
# define	BOXCAR_	298
# define	BOXCIRCLE_	299
# define	BUFFER_	300
# define	BW_	301
# define	CALLBACK_	302
# define	CANVAS_	303
# define	CENTER_	304
# define	CHANNEL_	305
# define	CIRCLE_	306
# define	CIAO_	307
# define	CLEAR_	308
# define	CLICK_	309
# define	CLIP_	310
# define	COLORMAP_	311
# define	COLOR_	312
# define	COLORSCALE_	313
# define	COLORSPACE_	314
# define	COLS_	315
# define	COMMAND_	316
# define	COMPASS_	317
# define	CONTOUR_	318
# define	CONVERT_	319
# define	COORDINATES_	320
# define	COPY_	321
# define	COUNT_	322
# define	CURSOR_	323
# define	CREATE_	324
# define	CROSS_	325
# define	CROSSHAIR_	326
# define	CUBE_	327
# define	CUT_	328
# define	CMYK_	329
# define	DATA_	330
# define	DATAMIN_	331
# define	DATASEC_	332
# define	DEBUG_	333
# define	DEGREES_	334
# define	DEFAULT_	335
# define	DELETE_	336
# define	DEPTH_	337
# define	DETECTOR_	338
# define	DIAMOND_	339
# define	DISTANCE_	340
# define	DS9_	341
# define	EDIT_	342
# define	ECLIPTIC_	343
# define	ELLIPSE_	344
# define	END_	345
# define	EQUATORIAL_	346
# define	ERASE_	347
# define	EXPORT_	348
# define	EXT_	349
# define	FACTOR_	350
# define	FALSE_	351
# define	FAST_	352
# define	FG_	353
# define	FILE_	354
# define	FILTER_	355
# define	FIT_	356
# define	FITS_	357
# define	FITSY_	358
# define	FIXED_	359
# define	FK4_	360
# define	FK5_	361
# define	FONT_	362
# define	FRONT_	363
# define	FULL_	364
# define	FUNCTION_	365
# define	GALACTIC_	366
# define	GAUSSIAN_	367
# define	GET_	368
# define	GLOBAL_	369
# define	GRAPHICS_	370
# define	GRAY_	371
# define	GRID_	372
# define	GZ_	373
# define	HANDLE_	374
# define	HAS_	375
# define	HEADER_	376
# define	HEIGHT_	377
# define	HIDE_	378
# define	HIGH_	379
# define	HIGHLITE_	380
# define	HISTEQU_	381
# define	HISTOGRAM_	382
# define	HMS_	383
# define	HORIZONTAL_	384
# define	ICRS_	385
# define	ID_	386
# define	IIS_	387
# define	IMAGE_	388
# define	INCLUDE_	389
# define	INCR_	390
# define	INFO_	391
# define	INTEGER_	392
# define	INTERPOLATE_	393
# define	IRAF_	394
# define	IRAFMIN_	395
# define	J2000_	396
# define	JPEG_	397
# define	KEY_	398
# define	KEYWORD_	399
# define	LABEL_	400
# define	LENGTH_	401
# define	LEVEL_	402
# define	LINE_	403
# define	LINEAR_	404
# define	LIST_	405
# define	LOAD_	406
# define	LOCAL_	407
# define	LOG_	408
# define	LOW_	409
# define	MAGNIFIER_	410
# define	MAP_	411
# define	MARK_	412
# define	MARKER_	413
# define	MASTER_	414
# define	MESSAGE_	415
# define	METHOD_	416
# define	MINMAX_	417
# define	MMAP_	418
# define	MMAPINCR_	419
# define	MOSAIC_	420
# define	MODE_	421
# define	MOTION_	422
# define	MOVE_	423
# define	NAME_	424
# define	NAN_	425
# define	NEW_	426
# define	NEXT_	427
# define	NO_	428
# define	NONE_	429
# define	NOW_	430
# define	NUMBER_	431
# define	OBJECT_	432
# define	OFF_	433
# define	ON_	434
# define	OPTION_	435
# define	ORIENT_	436
# define	PAN_	437
# define	PANDA_	438
# define	PANNER_	439
# define	PARAM_	440
# define	PARSER_	441
# define	PASTE_	442
# define	PATH_	443
# define	PERF_	444
# define	PHYSICAL_	445
# define	PIXELS_	446
# define	PNG_	447
# define	POINT_	448
# define	POLYGON_	449
# define	POSTSCRIPT_	450
# define	PPM_	451
# define	PROJECTION_	452
# define	PROPERTY_	453
# define	PUBLICATION_	454
# define	PROS_	455
# define	RADIUS_	456
# define	REGION_	457
# define	REPLACE_	458
# define	RESAMPLE_	459
# define	RESET_	460
# define	RESOLUTION_	461
# define	RGB_	462
# define	ROOT_	463
# define	ROTATE_	464
# define	RULER_	465
# define	SAMPLE_	466
# define	SAOIMAGE_	467
# define	SAOTNG_	468
# define	SAVE_	469
# define	SCAN_	470
# define	SCIENTIFIC_	471
# define	SCOPE_	472
# define	SEGMENT_	473
# define	SELECT_	474
# define	SET_	475
# define	SEXAGESIMAL_	476
# define	SHARED_	477
# define	SHIFT_	478
# define	SHMID_	479
# define	SHOW_	480
# define	SIZE_	481
# define	SKY_	482
# define	SLAVE_	483
# define	SLICE_	484
# define	SMOOTH_	485
# define	SOCKET_	486
# define	SOCKETGZ_	487
# define	SOURCE_	488
# define	SQRT_	489
# define	SQUARED_	490
# define	STATUS_	491
# define	SUM_	492
# define	SYSTEM_	493
# define	TABLE_	494
# define	TAG_	495
# define	TEXT_	496
# define	THICK_	497
# define	TIFF_	498
# define	TO_	499
# define	TOPHAT_	500
# define	TRUE_	501
# define	TYPE_	502
# define	UNDO_	503
# define	UNLOAD_	504
# define	UNSELECT_	505
# define	UPDATE_	506
# define	USER_	507
# define	VALUE_	508
# define	VAR_	509
# define	VIEW_	510
# define	VERSION_	511
# define	VERTEX_	512
# define	VERTICAL_	513
# define	WARP_	514
# define	WCS_	515
# define	WCSA_	516
# define	WCSB_	517
# define	WCSC_	518
# define	WCSD_	519
# define	WCSE_	520
# define	WCSF_	521
# define	WCSG_	522
# define	WCSH_	523
# define	WCSI_	524
# define	WCSJ_	525
# define	WCSK_	526
# define	WCSL_	527
# define	WCSM_	528
# define	WCSN_	529
# define	WCSO_	530
# define	WCSP_	531
# define	WCSQ_	532
# define	WCSR_	533
# define	WCSS_	534
# define	WCST_	535
# define	WCSU_	536
# define	WCSV_	537
# define	WCSW_	538
# define	WCSX_	539
# define	WCSY_	540
# define	WCSZ_	541
# define	WFPC2_	542
# define	WIDTH_	543
# define	XY_	544
# define	YES_	545
# define	ZMAX_	546
# define	ZSCALE_	547
# define	ZOOM_	548


extern YYSTYPE frlval;

#endif /* not BISON_PARSER_H */
