#ifndef BISON_TNGPARSER_H
# define BISON_TNGPARSER_H

#ifndef YYSTYPE
typedef union {
  double real;
  int integer;
  char str[256];
  double vector[3];
} yystype;
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif
# define	INT	257
# define	REAL	258
# define	STRING	259
# define	DEGREE	260
# define	SEXSTR	261
# define	BACKGROUND_	262
# define	BOX_	263
# define	BLACK_	264
# define	BLUE_	265
# define	CIRCLE_	266
# define	CYAN_	267
# define	DATE_	268
# define	DEBUG_	269
# define	DEGREES_	270
# define	ECLIPTIC_	271
# define	ELLIPSE_	272
# define	FILENAME_	273
# define	FK4_	274
# define	FK5_	275
# define	FORMAT_	276
# define	GALACTIC_	277
# define	GREEN_	278
# define	HMS_	279
# define	ICRS_	280
# define	LINE_	281
# define	MAGENTA_	282
# define	OFF_	283
# define	ON_	284
# define	PHYSICAL_	285
# define	PIXELS_	286
# define	POINT_	287
# define	POLYGON_	288
# define	RED_	289
# define	SOURCE_	290
# define	TEXT_	291
# define	VERSION_	292
# define	WHITE_	293
# define	YELLOW_	294


extern YYSTYPE tnglval;

#endif /* not BISON_TNGPARSER_H */
