#ifndef BISON_XYPARSER_H
# define BISON_XYPARSER_H

#ifndef YYSTYPE
typedef union {
  double real;
  int integer;
  char str[256];
  double vector[3];
} yystype;
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif
# define	INT	257
# define	REAL	258
# define	HOUR	259
# define	MINUTE	260
# define	SECOND	261
# define	DEGREE	262
# define	ARCMINUTE	263
# define	ARCSECOND	264
# define	SEXSTR	265
# define	AMPLIFIER_	266
# define	B1950_	267
# define	CCD_	268
# define	DEBUG_	269
# define	DETECTOR_	270
# define	ECLIPTIC_	271
# define	FK4_	272
# define	FK5_	273
# define	GALACTIC_	274
# define	ICRS_	275
# define	IMAGE_	276
# define	J2000_	277
# define	LOGICAL_	278
# define	OFF_	279
# define	ON_	280
# define	PHYSICAL_	281
# define	VERSION_	282
# define	WCS_	283
# define	WCSA_	284
# define	WCSB_	285
# define	WCSC_	286
# define	WCSD_	287
# define	WCSE_	288
# define	WCSF_	289
# define	WCSG_	290
# define	WCSH_	291
# define	WCSI_	292
# define	WCSJ_	293
# define	WCSK_	294
# define	WCSL_	295
# define	WCSM_	296
# define	WCSN_	297
# define	WCSO_	298
# define	WCSP_	299
# define	WCSQ_	300
# define	WCSR_	301
# define	WCSS_	302
# define	WCST_	303
# define	WCSU_	304
# define	WCSV_	305
# define	WCSW_	306
# define	WCSX_	307
# define	WCSY_	308
# define	WCSZ_	309


extern YYSTYPE xylval;

#endif /* not BISON_XYPARSER_H */
